<?php
class ControllerModuleHTMLEmail extends Controller {
	private $error = array(); 
	private $version = '1.4';
	
	public function saveSettings() {
		$this->load->language('module/html_email');
		
		$this->load->model('setting/setting');
		
		$json = array();
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			
			$this->model_setting_setting->editSetting('html_email', $this->request->post);		
					
			$json['success'] = $this->language->get('text_success');
		
		} else {
			$json['error'] = $this->error;
		}		
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
  	}
	
	public function index() {   
		$this->load->language('module/html_email');

		$this->load->model('tool/image');
		
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->document->addScript('view/javascript/jquery/bootstrap-colorpicker/bootstrap-colorpicker.js');
		$this->document->addStyle('view/stylesheet/bootstrap-colorpicker.css');
		$this->document->addStyle('view/stylesheet/html_email.css');
				 
		$data['heading_title'] = $this->language->get('heading_title') . ' ' . $this->version;

		$data['tab_template'] = $this->language->get('tab_template');
		$data['tab_email_page'] = $this->language->get('tab_email_page');
		$data['tab_email_top_bar'] = $this->language->get('tab_email_top_bar');
		$data['tab_email_header'] = $this->language->get('tab_email_header');
		$data['tab_email_featured'] = $this->language->get('tab_email_featured');
		$data['tab_email_main'] = $this->language->get('tab_email_main');
		$data['tab_email_footer'] = $this->language->get('tab_email_footer');
		$data['tab_email_subfooter'] = $this->language->get('tab_email_subfooter');
		$data['tab_language_settings'] = $this->language->get('tab_language_settings');
		$data['tab_help'] = $this->language->get('tab_help');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_send_test'] = $this->language->get('text_send_test');
		
		$data['entry_background_color'] = $this->language->get('entry_background_color');
		$data['entry_text_color'] = $this->language->get('entry_text_color');
		$data['entry_link_color'] = $this->language->get('entry_link_color');	
		$data['entry_table_border_color'] = $this->language->get('entry_table_border_color');	
		$data['entry_table_header_bg'] = $this->language->get('entry_table_header_bg');	
		$data['entry_table_header_text_color'] = $this->language->get('entry_table_header_text_color');	
		$data['entry_table_body_bg'] = $this->language->get('entry_table_body_bg');	
		$data['entry_table_body_text_color'] = $this->language->get('entry_table_body_text_color');	
		$data['entry_logo'] = $this->language->get('entry_logo');	
		$data['entry_logo_width'] = $this->language->get('entry_logo_width');	
		$data['entry_logo_height'] = $this->language->get('entry_logo_height');	
		$data['entry_logo_dimension'] = $this->language->get('entry_logo_dimension');	
		$data['entry_icon'] = $this->language->get('entry_icon');	
		$data['entry_link'] = $this->language->get('entry_link');	
		$data['entry_show_featured'] = $this->language->get('entry_show_featured');
		$data['entry_show_footer'] = $this->language->get('entry_show_footer');
			
		$data['entry_email'] = $this->language->get('entry_email');	
		
		// language messages
		$data['entry_view_store'] = $this->language->get('entry_view_store');
		$data['entry_contact_us'] = $this->language->get('entry_contact_us');
		$data['entry_my_account'] = $this->language->get('entry_my_account');
		$data['entry_featured_title'] = $this->language->get('entry_featured_title');
		$data['entry_featured_description'] = $this->language->get('entry_featured_description');
		$data['entry_featured_link'] = $this->language->get('entry_featured_link');
		$data['entry_featured_find_more_info'] = $this->language->get('entry_featured_find_more_info');
		$data['entry_footer_description'] = $this->language->get('entry_footer_description');	
		$data['entry_copyright'] = $this->language->get('entry_copyright');	
		
		// legend
		$data['legend_logo'] = $this->language->get('legend_logo');
		$data['legend_facebook'] = $this->language->get('legend_facebook');
		$data['legend_twitter'] = $this->language->get('legend_twitter');
		$data['legend_youtube'] = $this->language->get('legend_youtube');
		
		// help
		$data['help_choose_color'] = $this->language->get('help_choose_color');
		$data['help_32x32'] = $this->language->get('help_32x32');
		$data['help_facebook_link'] = $this->language->get('help_facebook_link');
		$data['help_twitter_link'] = $this->language->get('help_twitter_link');
		$data['help_youtube_link'] = $this->language->get('help_youtube_link');
		$data['help_px'] = $this->language->get('help_px');
		$data['help_logo_dimension'] = $this->language->get('help_logo_dimension');
		$data['help_show_featured'] = $this->language->get('help_show_featured');
		$data['help_show_footer'] = $this->language->get('help_show_footer');
		$data['help_featured_title'] = $this->language->get('help_featured_title');
		$data['help_featured_description'] = $this->language->get('help_featured_description');
		$data['help_featured_link'] = $this->language->get('help_featured_link');
		$data['help_featured_find_more_info'] = $this->language->get('help_featured_find_more_info');
		$data['help_my_account'] = $this->language->get('help_my_account');
		$data['help_footer_description'] = $this->language->get('help_footer_description');
		$data['help_view_store'] = $this->language->get('help_view_store');
		$data['help_contact_us'] = $this->language->get('help_contact_us');
		$data['help_copyright'] = $this->language->get('help_copyright'); 
		$data['help_layout_preview_title'] = $this->language->get('help_layout_preview_title');		
		$data['help_layout_preview_info'] = $this->language->get('help_layout_preview_info');		
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
		$data['button_send_test'] = $this->language->get('button_send_test');
		$data['button_send_now'] = $this->language->get('button_send_now');
		
 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL')
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
   		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/html_email', 'token=' . $this->session->data['token'], 'SSL')
   		);
		
		$data['action'] = $this->url->link('module/html_email', 'token=' . $this->session->data['token'], 'SSL');
		
		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		$this->update_check();
		
		if (isset($this->error['update'])) {
			$data['update'] = $this->error['update'];
		} else {
			$data['update'] = '';
		}		
		
		if (isset($this->request->post['html_email_default_word'])){
			$data['html_email_default_word'] = $this->request->post['html_email_default_word'];
		} elseif ( $this->config->get('html_email_default_word')){
			$data['html_email_default_word'] = $this->config->get('html_email_default_word');
		} else {
			$data['html_email_default_word'] = array();
		}
		
		if (isset($this->request->post['html_email_page_bg'])){
			$data['html_email_page_bg'] = $this->request->post['html_email_page_bg'];
		} elseif ( $this->config->get('html_email_page_bg')){
			$data['html_email_page_bg'] = $this->config->get('html_email_page_bg');
		} else {
			$data['html_email_page_bg'] = '#EFEFEF';
		}
		
		if (isset($this->request->post['html_email_top_bar_bg'])){
			$data['html_email_top_bar_bg'] = $this->request->post['html_email_top_bar_bg'];
		} elseif ( $this->config->get('html_email_top_bar_bg')){
			$data['html_email_top_bar_bg'] = $this->config->get('html_email_top_bar_bg');
		} else {
			$data['html_email_top_bar_bg'] = '#484848';
		}
		
		if (isset($this->request->post['html_email_top_bar_text_color'])){
			$data['html_email_top_bar_text_color'] = $this->request->post['html_email_top_bar_text_color'];
		} elseif ( $this->config->get('html_email_top_bar_text_color')){
			$data['html_email_top_bar_text_color'] = $this->config->get('html_email_top_bar_text_color');
		} else {
			$data['html_email_top_bar_text_color'] = '#D8D8D8';
		}
		
		if (isset($this->request->post['html_email_top_bar_link_color'])){
			$data['html_email_top_bar_link_color'] = $this->request->post['html_email_top_bar_link_color'];
		} elseif ( $this->config->get('html_email_top_bar_link_color')){
			$data['html_email_top_bar_link_color'] = $this->config->get('html_email_top_bar_link_color');
		} else {
			$data['html_email_top_bar_link_color'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_header_bg'])){
			$data['html_email_header_bg'] = $this->request->post['html_email_header_bg'];
		} elseif ( $this->config->get('html_email_header_bg')){
			$data['html_email_header_bg'] = $this->config->get('html_email_header_bg');
		} else {
			$data['html_email_header_bg'] = '#FFFFFF';
		}
		
		$data['placeholder'] = $this->model_tool_image->resize('placeholder.png', 100, 100);
		$data['icon_placeholder'] = $this->model_tool_image->resize('placeholder.png', 32, 32);
		
		if (isset($this->request->post['html_email_logo'])){
			$data['html_email_logo'] = $this->request->post['html_email_logo'];
		} elseif ( $this->config->get('html_email_logo')){
			$data['html_email_logo'] = $this->config->get('html_email_logo');
		} else {
			$data['html_email_logo'] = $this->config->get('config_logo');
		}
		
		if ($this->config->get('html_email_logo') && file_exists(DIR_IMAGE . $this->config->get('html_email_logo')) && is_file(DIR_IMAGE . $this->config->get('html_email_logo'))) {
			$data['logo'] = $this->model_tool_image->resize($this->config->get('html_email_logo'), 100, 100);		
		} elseif ($this->config->get('config_logo') && file_exists(DIR_IMAGE . $this->config->get('config_logo')) && is_file(DIR_IMAGE . $this->config->get('config_logo'))) {
			$data['logo'] = $this->model_tool_image->resize($this->config->get('config_logo'), 100, 100);		
		} else {
			$data['logo'] = $this->model_tool_image->resize('placeholder.png', 100, 100);
		}
		
		if (isset($this->request->post['html_email_logo_width'])){
			$data['html_email_logo_width'] = $this->request->post['html_email_logo_width'];
		} elseif ( $this->config->get('html_email_logo_width')){
			$data['html_email_logo_width'] = $this->config->get('html_email_logo_width');
		} else {
			$data['html_email_logo_width'] = '';
		}
		
		if (isset($this->request->post['html_email_logo_height'])){
			$data['html_email_logo_height'] = $this->request->post['html_email_logo_height'];
		} elseif ( $this->config->get('html_email_logo_height')){
			$data['html_email_logo_height'] = $this->config->get('html_email_logo_height');
		} else {
			$data['html_email_logo_height'] = '';
		}
		
		if (isset($this->request->post['html_email_fb_link'])){
			$data['html_email_fb_link'] = $this->request->post['html_email_fb_link'];
		} elseif ( $this->config->get('html_email_fb_link')){
			$data['html_email_fb_link'] = $this->config->get('html_email_fb_link');
		} else {
			$data['html_email_fb_link'] = '';
		}
		
		if (isset($this->request->post['html_email_tw_link'])){
			$data['html_email_tw_link'] = $this->request->post['html_email_tw_link'];
		} elseif ( $this->config->get('html_email_tw_link')){
			$data['html_email_tw_link'] = $this->config->get('html_email_tw_link');
		} else {
			$data['html_email_tw_link'] = '';
		}
		
		if (isset($this->request->post['html_email_yt_link'])){
			$data['html_email_yt_link'] = $this->request->post['html_email_yt_link'];
		} elseif ( $this->config->get('html_email_yt_link')){
			$data['html_email_yt_link'] = $this->config->get('html_email_yt_link');
		} else {
			$data['html_email_yt_link'] = '';
		}
		
		if (isset($this->request->post['html_email_facebook_icon'])){
			$data['html_email_facebook_icon'] = $this->request->post['html_email_facebook_icon'];
		} elseif ( $this->config->get('html_email_facebook_icon')){
			$data['html_email_facebook_icon'] = $this->config->get('html_email_facebook_icon');
		} else {
			$data['html_email_facebook_icon'] = 'catalog/html_email_social/facebook.png';
		}
		
		if ($this->config->get('html_email_facebook_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_facebook_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_facebook_icon'))) {
			$data['facebook_icon'] = $this->model_tool_image->resize($this->config->get('html_email_facebook_icon'), 32, 32);		
		} else {
			$data['facebook_icon'] = $this->model_tool_image->resize('catalog/html_email_social/facebook.png', 32, 32);
		}		
		
		if (isset($this->request->post['html_email_twitter_icon'])){
			$data['html_email_twitter_icon'] = $this->request->post['html_email_twitter_icon'];
		} elseif ( $this->config->get('html_email_twitter_icon')){
			$data['html_email_twitter_icon'] = $this->config->get('html_email_twitter_icon');
		} else {
			$data['html_email_twitter_icon'] = 'catalog/html_email_social/twitter.png';
		}
		
		if ($this->config->get('html_email_twitter_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_twitter_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_twitter_icon'))) {
			$data['twitter_icon'] = $this->model_tool_image->resize($this->config->get('html_email_twitter_icon'), 32, 32);		
		} else {
			$data['twitter_icon'] = $this->model_tool_image->resize('catalog/html_email_social/twitter.png', 32, 32);
		}
		
		if (isset($this->request->post['html_email_youtube_icon'])){
			$data['html_email_youtube_icon'] = $this->request->post['html_email_youtube_icon'];
		} elseif ( $this->config->get('html_email_youtube_icon')){
			$data['html_email_youtube_icon'] = $this->config->get('html_email_youtube_icon');
		} else {
			$data['html_email_youtube_icon'] = 'catalog/html_email_social/youtube.png';
		}
		
		if ($this->config->get('html_email_youtube_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_youtube_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_youtube_icon'))) {
			$data['youtube_icon'] = $this->model_tool_image->resize($this->config->get('html_email_youtube_icon'), 32, 32);		
		} else {
			$data['youtube_icon'] = $this->model_tool_image->resize('catalog/html_email_social/youtube.png', 32, 32);
		}
		
		if (isset($this->request->post['html_email_show_featured'])){
			$data['html_email_show_featured'] = $this->request->post['html_email_show_featured'];
		} elseif ($this->config->get('html_email_show_featured')){
			$data['html_email_show_featured'] = $this->config->get('html_email_show_featured');
		} else {
			$data['html_email_show_featured'] = 1;
		}
		
		if (isset($this->request->post['html_email_featured_bg'])){
			$data['html_email_featured_bg'] = $this->request->post['html_email_featured_bg'];
		} elseif ( $this->config->get('html_email_featured_bg')){
			$data['html_email_featured_bg'] = $this->config->get('html_email_featured_bg');
		} else {
			$data['html_email_featured_bg'] = '#3498DB';
		}
		
		if (isset($this->request->post['html_email_featured_text_color'])){
			$data['html_email_featured_text_color'] = $this->request->post['html_email_featured_text_color'];
		} elseif ( $this->config->get('html_email_featured_text_color')){
			$data['html_email_featured_text_color'] = $this->config->get('html_email_featured_text_color');
		} else {
			$data['html_email_featured_text_color'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_featured_link_color'])){
			$data['html_email_featured_link_color'] = $this->request->post['html_email_featured_link_color'];
		} elseif ( $this->config->get('html_email_featured_link_color')){
			$data['html_email_featured_link_color'] = $this->config->get('html_email_featured_link_color');
		} else {
			$data['html_email_featured_link_color'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_main_bg'])){
			$data['html_email_main_bg'] = $this->request->post['html_email_main_bg'];
		} elseif ( $this->config->get('html_email_main_bg')){
			$data['html_email_main_bg'] = $this->config->get('html_email_main_bg');
		} else {
			$data['html_email_main_bg'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_main_text_color'])){
			$data['html_email_main_text_color'] = $this->request->post['html_email_main_text_color'];
		} elseif ( $this->config->get('html_email_main_text_color')){
			$data['html_email_main_text_color'] = $this->config->get('html_email_main_text_color');
		} else {
			$data['html_email_main_text_color'] = '#696969';
		}
		
		if (isset($this->request->post['html_email_main_link_color'])){
			$data['html_email_main_link_color'] = $this->request->post['html_email_main_link_color'];
		} elseif ( $this->config->get('html_email_main_link_color')){
			$data['html_email_main_link_color'] = $this->config->get('html_email_main_link_color');
		} else {
			$data['html_email_main_link_color'] = '#696969';
		}
		
		if (isset($this->request->post['html_email_main_table_border_color'])){
			$data['html_email_main_table_border_color'] = $this->request->post['html_email_main_table_border_color'];
		} elseif ( $this->config->get('html_email_main_table_border_color')){
			$data['html_email_main_table_border_color'] = $this->config->get('html_email_main_table_border_color');
		} else {
			$data['html_email_main_table_border_color'] = '#DDDDDD';
		}
		
		if (isset($this->request->post['html_email_main_table_header_bg'])){
			$data['html_email_main_table_header_bg'] = $this->request->post['html_email_main_table_header_bg'];
		} elseif ( $this->config->get('html_email_main_table_header_bg')){
			$data['html_email_main_table_header_bg'] = $this->config->get('html_email_main_table_header_bg');
		} else {
			$data['html_email_main_table_header_bg'] = '#EFEFEF';
		}
		
		if (isset($this->request->post['html_email_main_table_header_text_color'])){
			$data['html_email_main_table_header_text_color'] = $this->request->post['html_email_main_table_header_text_color'];
		} elseif ( $this->config->get('html_email_main_table_header_text_color')){
			$data['html_email_main_table_header_text_color'] = $this->config->get('html_email_main_table_header_text_color');
		} else {
			$data['html_email_main_table_header_text_color'] = '#222222';
		}
		
		if (isset($this->request->post['html_email_main_table_body_bg'])){
			$data['html_email_main_table_body_bg'] = $this->request->post['html_email_main_table_body_bg'];
		} elseif ( $this->config->get('html_email_main_table_body_bg')){
			$data['html_email_main_table_body_bg'] = $this->config->get('html_email_main_table_body_bg');
		} else {
			$data['html_email_main_table_body_bg'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_main_table_body_text_color'])){
			$data['html_email_main_table_body_text_color'] = $this->request->post['html_email_main_table_body_text_color'];
		} elseif ( $this->config->get('html_email_main_table_body_text_color')){
			$data['html_email_main_table_body_text_color'] = $this->config->get('html_email_main_table_body_text_color');
		} else {
			$data['html_email_main_table_body_text_color'] = '#696969';
		}
		
		if (isset($this->request->post['html_email_show_footer'])){
			$data['html_email_show_footer'] = $this->request->post['html_email_show_footer'];
		} elseif ($this->config->get('html_email_show_footer')){
			$data['html_email_show_footer'] = $this->config->get('html_email_show_footer');
		} else {
			$data['html_email_show_footer'] = 1;
		}
		
		if (isset($this->request->post['html_email_footer_bg'])){
			$data['html_email_footer_bg'] = $this->request->post['html_email_footer_bg'];
		} elseif ( $this->config->get('html_email_footer_bg')){
			$data['html_email_footer_bg'] = $this->config->get('html_email_footer_bg');
		} else {
			$data['html_email_footer_bg'] = '#545454';
		}
		
		if (isset($this->request->post['html_email_footer_text_color'])){
			$data['html_email_footer_text_color'] = $this->request->post['html_email_footer_text_color'];
		} elseif ( $this->config->get('html_email_footer_text_color')){
			$data['html_email_footer_text_color'] = $this->config->get('html_email_footer_text_color');
		} else {
			$data['html_email_footer_text_color'] = '#D8D8D8';
		}
		
		if (isset($this->request->post['html_email_footer_link_color'])){
			$data['html_email_footer_link_color'] = $this->request->post['html_email_footer_link_color'];
		} elseif ( $this->config->get('html_email_footer_link_color')){
			$data['html_email_footer_link_color'] = $this->config->get('html_email_footer_link_color');
		} else {
			$data['html_email_footer_link_color'] = '#FFFFFF';
		}
		
		if (isset($this->request->post['html_email_subfooter_bg'])){
			$data['html_email_subfooter_bg'] = $this->request->post['html_email_subfooter_bg'];
		} elseif ( $this->config->get('html_email_subfooter_bg')){
			$data['html_email_subfooter_bg'] = $this->config->get('html_email_subfooter_bg');
		} else {
			$data['html_email_subfooter_bg'] = '#484848';
		}
		
		if (isset($this->request->post['html_email_subfooter_text_color'])){
			$data['html_email_subfooter_text_color'] = $this->request->post['html_email_subfooter_text_color'];
		} elseif ( $this->config->get('html_email_subfooter_text_color')){
			$data['html_email_subfooter_text_color'] = $this->config->get('html_email_subfooter_text_color');
		} else {
			$data['html_email_subfooter_text_color'] = '#D8D8D8';
		}
		
		$data['default_email'] = $this->config->get('config_email');
		
		$this->load->model('localisation/language');
		$data['languages'] = $this->model_localisation_language->getLanguages();
		
		$data['token'] = $this->session->data['token'];
						 
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/html_email.tpl', $data));
	}
	
	private function validate() {
	
		if (!$this->user->hasPermission('modify', 'module/html_email')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		$dinamic_strlen = 'utf8_strlen';
		 
		if ( !function_exists('utf8_strlen') ) {
			$dinamic_strlen = 'strlen';
		}
		
		if (isset($this->request->post['html_email_default_word'])) {
			foreach ($this->request->post['html_email_default_word'] as $language_id => $value) {
				if ($dinamic_strlen($value['view_store']) < 1) {
					$this->error['view_store'][$language_id] = $this->language->get('error_required');
				}
				
				if ($dinamic_strlen($value['contact_us']) < 1) {
					$this->error['contact_us'][$language_id] = $this->language->get('error_required');
				}
				
				if ($dinamic_strlen($value['my_account']) < 1) {
					$this->error['my_account'][$language_id] = $this->language->get('error_required');
				}

				if ($dinamic_strlen($value['featured_title']) < 1) {
					$this->error['featured_title'][$language_id] = $this->language->get('error_required');
				}
				
				if ($dinamic_strlen(html_entity_decode($value['featured_description'], ENT_QUOTES, 'UTF-8')) < 20) {
					$this->error['featured_description'][$language_id] = $this->language->get('error_min_chars_required');
				}
				
				if ($dinamic_strlen($value['find_more_info']) < 1) {
					$this->error['find_more_info'][$language_id] = $this->language->get('error_required');
				}
				
				if ($dinamic_strlen($value['featured_link']) < 1) {
					$this->error['featured_link'][$language_id] = $this->language->get('error_required');
				}
				
				if ($dinamic_strlen(html_entity_decode($value['footer_description'], ENT_QUOTES, 'UTF-8')) < 20) {
					$this->error['footer_description'][$language_id] = $this->language->get('error_min_chars_required');
				}
				
				if ($dinamic_strlen($value['copyright']) < 1) {
					$this->error['copyright'][$language_id] = $this->language->get('error_required');
				}
			}
			
			if (!isset($this->error['warning']) && count($this->error) != 0) {
				$this->error['warning'] = $this->language->get('error_in_language');
			}
		}	
			
		return !$this->error;
	}
	
	public function sendTestEmail() {
		$this->load->language('module/html_email');
		
		$this->load->model('tool/html_email');
		
		$json = array();
				
		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if (!$this->user->hasPermission('modify', 'module/html_email')) {
				$json['error']['warning'] = $this->language->get('error_permission');
			}
			
			$dinamic_strlen = 'utf8_strlen';
		 
			if ( !function_exists('utf8_strlen') ) {
				$dinamic_strlen = 'strlen';
			}
					
			if (!$this->request->post['emails']) {
				$json['error']['warning'] = $this->language->get('error_email_required');
			
			} else {
				
				$emails = explode(",", trim($this->request->post['emails']));
				
				foreach($emails as $email) {
					if (($dinamic_strlen(trim($email)) > 96) || !preg_match('/^[^\@]+@.*\.[a-z]{2,6}$/i', trim($email))) {
						$json['error']['warning'] = $this->language->get('error_email_wrong_format');
					}
				}
			}
			
			if (!$json) {
				
				$data['table_border_color'] = $this->config->get('html_email_main_table_border_color');		
				$data['table_header_bg'] = $this->config->get('html_email_main_table_header_bg');		
				$data['table_header_text_color'] = $this->config->get('html_email_main_table_header_text_color');		
				$data['table_body_bg'] = $this->config->get('html_email_main_table_body_bg');		
				$data['table_body_text_color'] = $this->config->get('html_email_main_table_body_text_color');
						
				$subject = $this->language->get('text_subject');
				
				$html = $this->model_tool_html_email->getHTMLEmail($this->config->get('config_language_id'), $subject, $this->load->view('mail/html_email_test.tpl', $data), 'html');
				
				if (VERSION == '2.0.0.0' || VERSION == '2.0.1.0' || VERSION == '2.0.1.1') {
					$mail = new Mail($this->config->get('config_mail'));	
				} else {
					$mail = new Mail();
					$mail->protocol = $this->config->get('config_mail_protocol');
					$mail->parameter = $this->config->get('config_mail_parameter');
					$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
					$mail->smtp_username = $this->config->get('config_mail_smtp_username');
					$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
					$mail->smtp_port = $this->config->get('config_mail_smtp_port');
					$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');
				}
				
				$mail->setFrom($this->config->get('config_email'));
				$mail->setSender($this->config->get('config_name'));
				$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
					
				foreach ($emails as $email) {
					$mail->setTo($email);					
					$mail->setHtml($html);
					$mail->send();
				}
				
				$json['success'] = $this->language->get('text_success_test_email');
			}
		} else {
			
			$data['text_test_email'] = $this->language->get('text_test_email');
			$data['text_multiple_emails'] = $this->language->get('text_multiple_emails');
			
			$data['entry_email'] = $this->language->get('entry_email');
			
			$data['help_email'] = $this->language->get('help_email');
			
			$data['button_send_now'] = $this->language->get('button_send_now');
			
			$json['output'] = $this->load->view('module/html_email_modal.tpl', $data);
		}
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
  	}

	private function update_check() {
		$data = 'v=' . $this->version . '&ex=20&e=' . $this->config->get('config_email') . '&ocv=' . VERSION;
        $curl = false;
        
        if (extension_loaded('curl')) {
			$ch = curl_init();
			
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_URL, 'https://www.oc-extensions.com/api/v1/update_check');
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);
            curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'OCX-Adaptor: curl'));
			curl_setopt($ch, CURLOPT_REFERER, HTTP_CATALOG);
			
			if (function_exists('gzinflate')) {
				curl_setopt($ch, CURLOPT_ENCODING, 'gzip');
			}
            
			$result = curl_exec($ch);
			$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			
			if ($http_code == 200) {
				$result = json_decode($result);
				
                if ($result) {
                    $curl = true;
                }
                
                if ( isset($result->version) && ($result->version > $this->version) ) {
				    $this->error['update'] = 'A new version of this extension is available. <a target="_blank" href="' . $result->url . '">Click here</a> to see the Changelog.';
				}
			}
		}
        
        if (!$curl) {
			if (!$fp = @fsockopen('ssl://www.oc-extensions.com', 443, $errno, $errstr, 20)) {
				return false;
			}

			socket_set_timeout($fp, 20);
			
			$headers = array();
			$headers[] = "POST /api/v1/update_check HTTP/1.0";
			$headers[] = "Host: www.oc-extensions.com";
			$headers[] = "Referer: " . HTTP_CATALOG;
			$headers[] = "OCX-Adaptor: socket";
			if (function_exists('gzinflate')) {
				$headers[] = "Accept-encoding: gzip";
			}	
			$headers[] = "Content-Type: application/x-www-form-urlencoded";
			$headers[] = "Accept: application/json";
			$headers[] = 'Content-Length: '.strlen($data);
			$request = implode("\r\n", $headers)."\r\n\r\n".$data;
			fwrite($fp, $request);
			$response = $http_code = null;
			$in_headers = $at_start = true;
			$gzip = false;
			
			while (!feof($fp)) {
				$line = fgets($fp, 4096);
				
				if ($at_start) {
					$at_start = false;
					
					if (!preg_match('/HTTP\/(\\d\\.\\d)\\s*(\\d+)\\s*(.*)/', $line, $m)) {
						return false;
					}
					
					$http_code = $m[2];
					continue;
				}
				
				if ($in_headers) {

					if (trim($line) == '') {
						$in_headers = false;
						continue;
					}

					if (!preg_match('/([^:]+):\\s*(.*)/', $line, $m)) {
						continue;
					}
					
					if ( strtolower(trim($m[1])) == 'content-encoding' && trim($m[2]) == 'gzip') {
						$gzip = true;
					}
					
					continue;
				}
				
                $response .= $line;
			}
					
			fclose($fp);
			
			if ($http_code == 200) {
				if ($gzip && function_exists('gzinflate')) {
					$response = substr($response, 10);
					$response = gzinflate($response);
				}
				
				$result = json_decode($response);
				
                if ( isset($result->version) && ($result->version > $this->version) ) {
				    $this->error['update'] = 'A new version of this extension is available. <a target="_blank" href="' . $result->url . '">Click here</a> to see the Changelog.';
				}
			}
		}
	}	
}
?>