<?php
class ControllerModulePDFInvoice extends Controller {
	private $error = array();
	private $version = '1.3.1';	 
	
	public function index() {   
		$this->load->language('module/pdf_invoice');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('pdf_invoice', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}
				 
		$data['heading_title'] = $this->language->get('heading_title') . ' ' . $this->version;
		
		$data['tab_pdf_file']               = $this->language->get('tab_pdf_file');
		$data['tab_email_template']    	    = $this->language->get('tab_email_template');
		$data['tab_extra_option'] 	        = $this->language->get('tab_extra_option');
		$data['tab_help']       			= $this->language->get('tab_help');
		
		$data['text_edit']   			    = $this->language->get('text_edit');
		$data['text_enabled']   			= $this->language->get('text_enabled');
		$data['text_disabled']  			= $this->language->get('text_disabled');
		$data['text_yes']       			= $this->language->get('text_yes');
		$data['text_no']        			= $this->language->get('text_no');
		$data['text_cm']        			= $this->language->get('text_cm');
		$data['text_size_a4']        	    = $this->language->get('text_size_a4');
		$data['text_size_letter']    	    = $this->language->get('text_size_letter');
		$data['text_orientation_portrait']  = $this->language->get('text_orientation_portrait');
		$data['text_orientation_landscape'] = $this->language->get('text_orientation_landscape');
		$data['text_pdf_browser'] 		    = $this->language->get('text_pdf_browser');
		$data['text_pdf_download'] 		    = $this->language->get('text_pdf_download');
		
		$data['entry_page_size'] 			= $this->language->get('entry_page_size');
		$data['entry_page_orientation'] 	= $this->language->get('entry_page_orientation');
		$data['entry_page_margin_top'] 	    = $this->language->get('entry_page_margin_top');
		$data['entry_page_margin_right'] 	= $this->language->get('entry_page_margin_right');
		$data['entry_page_margin_bottom']   = $this->language->get('entry_page_margin_bottom');
		$data['entry_page_margin_left'] 	= $this->language->get('entry_page_margin_left');
		$data['entry_file_name'] 	        = $this->language->get('entry_file_name');
		$data['entry_save_location'] 	    = $this->language->get('entry_save_location');
		
		$data['entry_email_subject'] 	    = $this->language->get('entry_email_subject');
		$data['entry_email_message'] 	    = $this->language->get('entry_email_message');
		
		$data['entry_invoice_button'] 	    = $this->language->get('entry_invoice_button');
		$data['entry_autosend'] 	        = $this->language->get('entry_autosend');
		$data['entry_admin_copy']	        = $this->language->get('entry_admin_copy');
		
		$data['help_title_keywords'] 	    = $this->language->get('help_title_keywords');
		$data['help_page_size'] 			= $this->language->get('help_page_size');
		$data['help_page_orientation'] 	    = $this->language->get('help_page_orientation');
		$data['help_page_margin_top'] 	    = $this->language->get('help_page_margin_top');
		$data['help_page_margin_right'] 	= $this->language->get('help_page_margin_right');
		$data['help_page_margin_bottom']    = $this->language->get('help_page_margin_bottom');
		$data['help_page_margin_left'] 	    = $this->language->get('help_page_margin_left');
		$data['help_file_name'] 	        = $this->language->get('help_file_name');
		$data['help_file_name_keywords'] 	= $this->language->get('help_file_name_keywords');
		$data['help_save_location'] 	    = $this->language->get('help_save_location');
		$data['help_email_subject'] 	    = $this->language->get('help_email_subject');
		$data['help_email_message'] 	    = $this->language->get('help_email_message');
		$data['help_invoice_button'] 	    = $this->language->get('help_invoice_button');
		$data['help_autosend'] 	            = $this->language->get('help_autosend');
		$data['help_admin_copy']	        = $this->language->get('help_admin_copy');		
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
		if (isset($this->error['page_size'])) {
			$data['error_page_size'] = $this->error['page_size'];
		} else {
			$data['error_page_size'] = '';
		}	
		
		if (isset($this->error['page_orientation'])) {
			$data['error_page_orientation'] = $this->error['page_orientation'];
		} else {
			$data['error_page_orientation'] = '';
		}
		
		if (isset($this->error['margin_top'])) {
			$data['error_margin_top'] = $this->error['margin_top'];
		} else {
			$data['error_margin_top'] = '';
		}

		if (isset($this->error['margin_right'])) {
			$data['error_margin_right'] = $this->error['margin_right'];
		} else {
			$data['error_margin_right'] = '';
		}
		
		if (isset($this->error['margin_bottom'])) {
			$data['error_margin_bottom'] = $this->error['margin_bottom'];
		} else {
			$data['error_margin_bottom'] = '';
		}
		
		if (isset($this->error['margin_left'])) {
			$data['error_margin_left'] = $this->error['margin_left'];
		} else {
			$data['error_margin_left'] = '';
		}

		if (isset($this->error['file_name'])) {
			$data['error_file_name'] = $this->error['file_name'];
		} else {
			$data['error_file_name'] = '';
		}

		if (isset($this->error['save_location'])) {
			$data['error_save_location'] = $this->error['save_location'];
		} else {
			$data['error_save_location'] = '';
		}	

		if (isset($this->error['email_subject'])) {
			$data['error_email_subject'] = $this->error['email_subject'];
		} else {
			$data['error_email_subject'] = array();
		}		
		
		if (isset($this->error['email_message'])) {
			$data['error_email_message'] = $this->error['email_message'];
		} else {
			$data['error_email_message'] = array();
		}	
		
		if (isset($this->error['invoice_button'])) {
			$data['error_invoice_button'] = $this->error['invoice_button'];
		} else {
			$data['error_invoice_button'] = '';
		}
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL')
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
   		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/pdf_invoice', 'token=' . $this->session->data['token'], 'SSL')
   		);
		
		$data['action'] = $this->url->link('module/pdf_invoice', 'token=' . $this->session->data['token'], 'SSL');
		
		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		$this->update_check();
		
		if (isset($this->error['update'])) {
			$data['update'] = $this->error['update'];
		} else {
			$data['update'] = '';
		}		
		
		if (isset($this->request->post['pdf_invoice_page_size'])){
			$data['pdf_invoice_page_size'] = $this->request->post['pdf_invoice_page_size'];
		} elseif ( $this->config->get('pdf_invoice_page_size')){
			$data['pdf_invoice_page_size'] = $this->config->get('pdf_invoice_page_size');
		} else {
			$data['pdf_invoice_page_size'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_page_orientation'])){
			$data['pdf_invoice_page_orientation'] = $this->request->post['pdf_invoice_page_orientation'];
		} elseif ( $this->config->get('pdf_invoice_page_orientation')){
			$data['pdf_invoice_page_orientation'] = $this->config->get('pdf_invoice_page_orientation');
		} else {
			$data['pdf_invoice_page_orientation'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_margin_top'])){
			$data['pdf_invoice_margin_top'] = $this->request->post['pdf_invoice_margin_top'];
		} elseif ( $this->config->get('pdf_invoice_margin_top')){
			$data['pdf_invoice_margin_top'] = $this->config->get('pdf_invoice_margin_top');
		} else {
			$data['pdf_invoice_margin_top'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_margin_right'])){
			$data['pdf_invoice_margin_right'] = $this->request->post['pdf_invoice_margin_right'];
		} elseif ( $this->config->get('pdf_invoice_margin_right')){
			$data['pdf_invoice_margin_right'] = $this->config->get('pdf_invoice_margin_right');
		} else {
			$data['pdf_invoice_margin_right'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_margin_bottom'])){
			$data['pdf_invoice_margin_bottom'] = $this->request->post['pdf_invoice_margin_bottom'];
		} elseif ( $this->config->get('pdf_invoice_margin_bottom')){
			$data['pdf_invoice_margin_bottom'] = $this->config->get('pdf_invoice_margin_bottom');
		} else {
			$data['pdf_invoice_margin_bottom'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_margin_left'])){
			$data['pdf_invoice_margin_left'] = $this->request->post['pdf_invoice_margin_left'];
		} elseif ( $this->config->get('pdf_invoice_margin_left')){
			$data['pdf_invoice_margin_left'] = $this->config->get('pdf_invoice_margin_left');
		} else {
			$data['pdf_invoice_margin_left'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_file_name'])){ 
			$data['pdf_invoice_file_name'] = $this->request->post['pdf_invoice_file_name'];
		} elseif ( $this->config->get('pdf_invoice_file_name')){
			$data['pdf_invoice_file_name'] = $this->config->get('pdf_invoice_file_name');
		} else {
			$data['pdf_invoice_file_name'] = '{invoice_prefix}_{invoice_no}_{order_id}.pdf';
		}
		
		if (isset($this->request->post['pdf_invoice_save_location'])){ 
			$data['pdf_invoice_save_location'] = $this->request->post['pdf_invoice_save_location'];
		} elseif ( $this->config->get('pdf_invoice_save_location')){
			$data['pdf_invoice_save_location'] = $this->config->get('pdf_invoice_save_location');
		} else {
			$data['pdf_invoice_save_location'] = DIR_DOWNLOAD .'pdf/';
		}
		
		if (isset($this->request->post['pdf_invoice_email_template'])){
			$data['pdf_invoice_email_template'] = $this->request->post['pdf_invoice_email_template'];
		} elseif ( $this->config->get('pdf_invoice_email_template')){
			$data['pdf_invoice_email_template'] = $this->config->get('pdf_invoice_email_template');
		} else {
			$data['pdf_invoice_email_template'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_invoice_button'])){
			$data['pdf_invoice_invoice_button'] = $this->request->post['pdf_invoice_invoice_button'];
		} elseif ( $this->config->get('pdf_invoice_invoice_button')){
			$data['pdf_invoice_invoice_button'] = $this->config->get('pdf_invoice_invoice_button');
		} else {
			$data['pdf_invoice_invoice_button'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_autosend'])){
			$data['pdf_invoice_autosend'] = $this->request->post['pdf_invoice_autosend'];
		} elseif ( $this->config->get('pdf_invoice_autosend')){
			$data['pdf_invoice_autosend'] = $this->config->get('pdf_invoice_autosend');
		} else {
			$data['pdf_invoice_autosend'] = '';
		}
		
		if (isset($this->request->post['pdf_invoice_admin_copy'])){
			$data['pdf_invoice_admin_copy'] = $this->request->post['pdf_invoice_admin_copy'];
		} elseif ( $this->config->get('pdf_invoice_admin_copy')){
			$data['pdf_invoice_admin_copy'] = $this->config->get('pdf_invoice_admin_copy');
		} else {
			$data['pdf_invoice_admin_copy'] = '';
		}
		
		$this->load->model('localisation/language');
		$data['languages'] = $this->model_localisation_language->getLanguages();
		
		$data['token'] = $this->session->data['token'];
						 
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
				
		$this->response->setOutput($this->load->view('module/pdf_invoice.tpl', $data));
	}
	
	private function validate() {
	
		if (!$this->user->hasPermission('modify', 'module/pdf_invoice')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		$dinamic_strlen = 'utf8_strlen';
		 
		if ( !function_exists('utf8_strlen') ) {
			$dinamic_strlen = 'strlen';
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_page_size']) == 0){
			$this->error['page_size'] = $this->language->get('error_page_size');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_page_orientation']) == 0){
			$this->error['page_orientation'] = $this->language->get('error_page_orientation');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_margin_top']) == 0){
			$this->error['margin_top'] = $this->language->get('error_page_margin');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_margin_right']) == 0){
			$this->error['margin_right'] = $this->language->get('error_page_margin');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_margin_bottom']) == 0){
			$this->error['margin_bottom'] = $this->language->get('error_page_margin');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_margin_left']) == 0){
			$this->error['margin_left'] = $this->language->get('error_page_margin');
		}
		
		if ($dinamic_strlen($this->request->post['pdf_invoice_file_name']) == 0 || substr(trim($this->request->post['pdf_invoice_file_name']), -4) != ".pdf"){
			$this->error['file_name'] = $this->language->get('error_file_name');
		}

		if ($dinamic_strlen($this->request->post['pdf_invoice_save_location']) == 0 || substr(trim($this->request->post['pdf_invoice_save_location']), -1) != "/"){
			$this->error['save_location'] = $this->language->get('error_save_location');
		}
		
		if (isset($this->request->post['pdf_invoice_email_template'])) {
			foreach ($this->request->post['pdf_invoice_email_template'] as $language_id => $value) {
				if ($dinamic_strlen($value['subject']) < 1) {
					$this->error['email_subject'][$language_id] = $this->language->get('error_email_subject');
				}
				
				if ($dinamic_strlen($value['message']) < 1) {
					$this->error['email_message'][$language_id] = $this->language->get('error_email_message');
				}			
			}
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
	
	private function update_check() {
		$data = 'v=' . $this->version . '&ex=18&e=' . $this->config->get('config_email') . '&ocv=' . VERSION;
        $curl = false;
        
        if (extension_loaded('curl')) {
			$ch = curl_init();
			
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_URL, 'https://www.oc-extensions.com/api/v1/update_check');
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);
            curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'OCX-Adaptor: curl'));
			curl_setopt($ch, CURLOPT_REFERER, HTTP_CATALOG);
			
			if (function_exists('gzinflate')) {
				curl_setopt($ch, CURLOPT_ENCODING, 'gzip');
			}
            
			$result = curl_exec($ch);
			$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			
			if ($http_code == 200) {
				$result = json_decode($result);
				
                if ($result) {
                    $curl = true;
                }
                
                if ( isset($result->version) && ($result->version > $this->version) ) {
				    $this->error['update'] = 'A new version of this extension is available. <a target="_blank" href="' . $result->url . '">Click here</a> to see the Changelog.';
				}
			}
		}
        
        if (!$curl) {
			if (!$fp = @fsockopen('ssl://www.oc-extensions.com', 443, $errno, $errstr, 20)) {
				return false;
			}

			socket_set_timeout($fp, 20);
			
			$headers = array();
			$headers[] = "POST /api/v1/update_check HTTP/1.0";
			$headers[] = "Host: www.oc-extensions.com";
			$headers[] = "Referer: " . HTTP_CATALOG;
			$headers[] = "OCX-Adaptor: socket";
			if (function_exists('gzinflate')) {
				$headers[] = "Accept-encoding: gzip";
			}	
			$headers[] = "Content-Type: application/x-www-form-urlencoded";
			$headers[] = "Accept: application/json";
			$headers[] = 'Content-Length: '.strlen($data);
			$request = implode("\r\n", $headers)."\r\n\r\n".$data;
			fwrite($fp, $request);
			$response = $http_code = null;
			$in_headers = $at_start = true;
			$gzip = false;
			
			while (!feof($fp)) {
				$line = fgets($fp, 4096);
				
				if ($at_start) {
					$at_start = false;
					
					if (!preg_match('/HTTP\/(\\d\\.\\d)\\s*(\\d+)\\s*(.*)/', $line, $m)) {
						return false;
					}
					
					$http_code = $m[2];
					continue;
				}
				
				if ($in_headers) {

					if (trim($line) == '') {
						$in_headers = false;
						continue;
					}

					if (!preg_match('/([^:]+):\\s*(.*)/', $line, $m)) {
						continue;
					}
					
					if ( strtolower(trim($m[1])) == 'content-encoding' && trim($m[2]) == 'gzip') {
						$gzip = true;
					}
					
					continue;
				}
				
                $response .= $line;
			}
					
			fclose($fp);
			
			if ($http_code == 200) {
				if ($gzip && function_exists('gzinflate')) {
					$response = substr($response, 10);
					$response = gzinflate($response);
				}
				
				$result = json_decode($response);
				
                if ( isset($result->version) && ($result->version > $this->version) ) {
				    $this->error['update'] = 'A new version of this extension is available. <a target="_blank" href="' . $result->url . '">Click here</a> to see the Changelog.';
				}
			}
		}
	}	
}
?>