<?php
class ControllerPaymentZGlobalPay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/zglobalpay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('zglobalpay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_authorize'] = $this->language->get('text_authorize');
		$data['text_pay'] = $this->language->get('text_pay');
		$data['text_disable_payment'] = $this->language->get('text_disable_payment');

		$data['entry_email'] = $this->language->get('entry_email');
		$data['entry_mertid'] = $this->language->get('entry_mertid');
		$data['entry_hash_key'] = $this->language->get('entry_hash_key');
		$data['entry_test'] = $this->language->get('entry_test');
		$data['entry_transaction'] = $this->language->get('entry_transaction');
		$data['entry_debug'] = $this->language->get('entry_debug');
		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_canceled_reversal_status'] = $this->language->get('entry_canceled_reversal_status');
		$data['entry_completed_status'] = $this->language->get('entry_completed_status');
		$data['entry_denied_status'] = $this->language->get('entry_denied_status');
		$data['entry_expired_status'] = $this->language->get('entry_expired_status');
		$data['entry_failed_status'] = $this->language->get('entry_failed_status');
		$data['entry_pending_status'] = $this->language->get('entry_pending_status');
		$data['entry_processed_status'] = $this->language->get('entry_processed_status');
		$data['entry_refunded_status'] = $this->language->get('entry_refunded_status');
		$data['entry_reversed_status'] = $this->language->get('entry_reversed_status');
		$data['entry_voided_status'] = $this->language->get('entry_voided_status');
		$data['entry_approved_status'] = $this->language->get('entry_approved_status');
		$data['entry_declined_status'] = $this->language->get('entry_declined_status');
		$data['entry_error_status'] = $this->language->get('entry_error_status');		
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['help_test'] = $this->language->get('help_test');
		$data['help_debug'] = $this->language->get('help_debug');
		$data['help_total'] = $this->language->get('help_total');
		$data['help_hash'] = $this->language->get('help_hash');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');
		$data['tab_order_status'] = $this->language->get('tab_order_status');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['mertid'])) {
			$data['error_mertid'] = $this->error['mertid'];
		} else {
			$data['error_mertid'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/zglobalpay', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('payment/zglobalpay', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['zglobalpay_mertid'])) {
			$data['zglobalpay_mertid'] = $this->request->post['zglobalpay_mertid'];
		} else {
			$data['zglobalpay_mertid'] = $this->config->get('zglobalpay_mertid');
		}

		if (isset($this->request->post['zglobalpay_test'])) {
			$data['zglobalpay_test'] = $this->request->post['zglobalpay_test'];
		} else {
			$data['zglobalpay_test'] = $this->config->get('zglobalpay_test');
		}

		if (isset($this->request->post['zglobalpay_transaction'])) {
			$data['zglobalpay_transaction'] = $this->request->post['zglobalpay_transaction'];
		} else {
			$data['zglobalpay_transaction'] = $this->config->get('zglobalpay_transaction');
		}

		if (isset($this->request->post['zglobalpay_debug'])) {
			$data['zglobalpay_debug'] = $this->request->post['zglobalpay_debug'];
		} else {
			$data['zglobalpay_debug'] = $this->config->get('zglobalpay_debug');
		}

		if (isset($this->request->post['zglobalpay_total'])) {
			$data['zglobalpay_total'] = $this->request->post['zglobalpay_total'];
		} else {
			$data['zglobalpay_total'] = $this->config->get('zglobalpay_total');
		}

		if (isset($this->request->post['zglobalpay_canceled_reversal_status_id'])) {
			$data['zglobalpay_canceled_reversal_status_id'] = $this->request->post['zglobalpay_canceled_reversal_status_id'];
		} else {
			$data['zglobalpay_canceled_reversal_status_id'] = $this->config->get('zglobalpay_canceled_reversal_status_id');
		}

		if (isset($this->request->post['zglobalpay_completed_status_id'])) {
			$data['zglobalpay_completed_status_id'] = $this->request->post['zglobalpay_completed_status_id'];
		} else {
			$data['zglobalpay_completed_status_id'] = $this->config->get('zglobalpay_completed_status_id');
		}

		if (isset($this->request->post['zglobalpay_denied_status_id'])) {
			$data['zglobalpay_denied_status_id'] = $this->request->post['zglobalpay_denied_status_id'];
		} else {
			$data['zglobalpay_denied_status_id'] = $this->config->get('zglobalpay_denied_status_id');
		}

		if (isset($this->request->post['zglobalpay_expired_status_id'])) {
			$data['zglobalpay_expired_status_id'] = $this->request->post['zglobalpay_expired_status_id'];
		} else {
			$data['zglobalpay_expired_status_id'] = $this->config->get('zglobalpay_expired_status_id');
		}

		if (isset($this->request->post['zglobalpay_failed_status_id'])) {
			$data['zglobalpay_failed_status_id'] = $this->request->post['zglobalpay_failed_status_id'];
		} else {
			$data['zglobalpay_failed_status_id'] = $this->config->get('zglobalpay_failed_status_id');
		}

		if (isset($this->request->post['zglobalpay_pending_status_id'])) {
			$data['zglobalpay_pending_status_id'] = $this->request->post['zglobalpay_pending_status_id'];
		} else {
			$data['zglobalpay_pending_status_id'] = $this->config->get('zglobalpay_pending_status_id');
		}

		if (isset($this->request->post['zglobalpay_processed_status_id'])) {
			$data['zglobalpay_processed_status_id'] = $this->request->post['zglobalpay_processed_status_id'];
		} else {
			$data['zglobalpay_processed_status_id'] = $this->config->get('zglobalpay_processed_status_id');
		}

		if (isset($this->request->post['zglobalpay_refunded_status_id'])) {
			$data['zglobalpay_refunded_status_id'] = $this->request->post['zglobalpay_refunded_status_id'];
		} else {
			$data['zglobalpay_refunded_status_id'] = $this->config->get('zglobalpay_refunded_status_id');
		}

		if (isset($this->request->post['zglobalpay_reversed_status_id'])) {
			$data['zglobalpay_reversed_status_id'] = $this->request->post['zglobalpay_reversed_status_id'];
		} else {
			$data['zglobalpay_reversed_status_id'] = $this->config->get('zglobalpay_reversed_status_id');
		}

		if (isset($this->request->post['zglobalpay_voided_status_id'])) {
			$data['zglobalpay_voided_status_id'] = $this->request->post['zglobalpay_voided_status_id'];
		} else {
			$data['zglobalpay_voided_status_id'] = $this->config->get('zglobalpay_voided_status_id');
		}

		if (isset($this->request->post['zglobalpay_approved_status_id'])) {
			$data['zglobalpay_approved_status_id'] = $this->request->post['zglobalpay_approved_status_id'];
		} else {
			$data['zglobalpay_approved_status_id'] = $this->config->get('zglobalpay_approved_status_id');
		}

		if (isset($this->request->post['zglobalpay_declined_status_id'])) {
			$data['zglobalpay_declined_status_id'] = $this->request->post['zglobalpay_declined_status_id'];
		} else {
			$data['zglobalpay_declined_status_id'] = $this->config->get('zglobalpay_declined_status_id');
		}

		if (isset($this->request->post['zglobalpay_error_status_id'])) {
			$data['zglobalpay_error_status_id'] = $this->request->post['zglobalpay_error_status_id'];
		} else {
			$data['zglobalpay_error_status_id'] = $this->config->get('zglobalpay_error_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['zglobalpay_geo_zone_id'])) {
			$data['zglobalpay_geo_zone_id'] = $this->request->post['zglobalpay_geo_zone_id'];
		} else {
			$data['zglobalpay_geo_zone_id'] = $this->config->get('zglobalpay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['zglobalpay_status'])) {
			$data['zglobalpay_status'] = $this->request->post['zglobalpay_status'];
		} else {
			$data['zglobalpay_status'] = $this->config->get('zglobalpay_status');
		}

		if (isset($this->request->post['zglobalpay_sort_order'])) {
			$data['zglobalpay_sort_order'] = $this->request->post['zglobalpay_sort_order'];
		} else {
			$data['zglobalpay_sort_order'] = $this->config->get('zglobalpay_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/zglobalpay.tpl', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/zglobalpay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['zglobalpay_mertid']) {
			$this->error['mertid'] = $this->language->get('error_mertid');
		}

		return !$this->error;
	}
}