<?php
//----------------------------------------------//
// Multiple Flat Rate Options
// For Opencart v2.x
// Version 2.0 - 2014.10.15
// Copyright 2012 - 2014 Nyco Agung
//----------------------------------------------//

class ControllerShippingFlatoptions extends Controller {
	private $error = array(); 	
	public function index() {   
		$this->language->load('shipping/flatoptions');
		$this->document->setTitle($this->language->get('heading_title'));		
		$this->load->model('setting/setting');
		$this->load->model('localisation/language');	
		$data['languages'] = $this->model_localisation_language->getLanguages();
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			//DO UPDATE
			$data['flatoptions_total'] = count($this->request->post['flatoptions_condition']);
			for($i=1;$i<=$data['flatoptions_total'];$i++){
				foreach($data['languages'] as $languages){
					$this->request->post['flatoptions_title_'.$languages['language_id'].'_'.$i] = $this->request->post['flatoptions_title'][$languages['language_id']][($i-1)];
				}				
				$this->request->post['flatoptions_condition_'.$i] = $this->request->post['flatoptions_condition'][($i-1)];
				$this->request->post['flatoptions_min_'.$i] = $this->request->post['flatoptions_min'][($i-1)];
				$this->request->post['flatoptions_max_'.$i] = $this->request->post['flatoptions_max'][($i-1)];
				$this->request->post['flatoptions_min_item_'.$i] = $this->request->post['flatoptions_min_item'][($i-1)];
				$this->request->post['flatoptions_max_item_'.$i] = $this->request->post['flatoptions_max_item'][($i-1)];
				$this->request->post['flatoptions_min_weight_'.$i] = $this->request->post['flatoptions_min_weight'][($i-1)];
				$this->request->post['flatoptions_max_weight_'.$i] = $this->request->post['flatoptions_max_weight'][($i-1)];
				$this->request->post['flatoptions_cost_'.$i] = $this->request->post['flatoptions_cost'][($i-1)];
				$this->request->post['flatoptions_tax_class_id_'.$i] = $this->request->post['flatoptions_tax_class_id'][($i-1)];
				$this->request->post['flatoptions_geo_zone_id_'.$i] = $this->request->post['flatoptions_geo_zone_id'][($i-1)];
				$this->request->post['flatoptions_enabled_'.$i] = $this->request->post['flatoptions_enabled'][($i-1)];
				$this->request->post['flatoptions_order_'.$i] = $this->request->post['flatoptions_order'][($i-1)];
			}		
			unset($this->request->post['flatoptions_title']);
			unset($this->request->post['flatoptions_condition']);
			unset($this->request->post['flatoptions_min']);
			unset($this->request->post['flatoptions_max']);
			unset($this->request->post['flatoptions_min_item']);
			unset($this->request->post['flatoptions_max_item']);
			unset($this->request->post['flatoptions_min_weight']);
			unset($this->request->post['flatoptions_max_weight']);
			unset($this->request->post['flatoptions_cost']);
			unset($this->request->post['flatoptions_tax_class_id']);
			unset($this->request->post['flatoptions_geo_zone_id']);
			unset($this->request->post['flatoptions_enabled']);
			unset($this->request->post['flatoptions_order']);

			$this->model_setting_setting->editSetting('flatoptions', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');						
			$this->response->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}
				
		$data['heading_title'] = $this->language->get('heading_title');
		$data['version_no'] = $this->language->get('version_no');
		$data['instructions'] = $this->language->get('instructions');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_custom_title'] = $this->language->get('text_custom_title');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');
		
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_condition'] = $this->language->get('entry_condition');
		$data['entry_condition_pleaseselect'] = $this->language->get('entry_condition_pleaseselect');
		$data['entry_condition_byorder'] = $this->language->get('entry_condition_byorder');
		$data['entry_condition_byitem'] = $this->language->get('entry_condition_byitem');
		$data['entry_condition_byweight'] = $this->language->get('entry_condition_byweight');
		$data['entry_condition_byorderitem'] = $this->language->get('entry_condition_byorderitem');
		$data['entry_condition_byorderweight'] = $this->language->get('entry_condition_byorderweight');
		$data['entry_condition_byitemweight'] = $this->language->get('entry_condition_byitemweight');
		$data['entry_order'] = $this->language->get('entry_order');
		$data['entry_item'] = $this->language->get('entry_item');		
		$data['entry_weight'] = $this->language->get('entry_weight');		
		$data['entry_min'] = $this->language->get('entry_min');
		$data['entry_max'] = $this->language->get('entry_max');
		$data['entry_cost'] = $this->language->get('entry_cost');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_add'] = $this->language->get('entry_add');
		$data['entry_remove'] = $this->language->get('entry_remove');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

  		$data['breadcrumbs'] = array();
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/flatoptions', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
		$data['action'] = $this->url->link('shipping/flatoptions', 'token=' . $this->session->data['token'], 'SSL');		
		$data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');
		
		//GET NUMBER OF FLATOPTIONS
		$query = $this->db->query("SELECT count('key') as total FROM " . DB_PREFIX . "setting as setting WHERE setting.key like 'flatoptions_condition_%'");		
		$data['flatoptions_total'] = $query->row['total'];
		$data['flatoptions_custom_title'] = $this->config->get('flatoptions_custom_title');
		$data['flatoptions_sort_order'] = $this->config->get('flatoptions_sort_order');
		$data['flatoptions_status'] = $this->config->get('flatoptions_status');
		
		//SUPPORT MULTILANGUAGES
		for($i=1;$i<=$data['flatoptions_total'];$i++){
			$data['flatoptions_condition_'.$i] = $this->config->get('flatoptions_condition_'.$i);
			$data['flatoptions_min_'.$i] = $this->config->get('flatoptions_min_'.$i);
			$data['flatoptions_max_'.$i] = $this->config->get('flatoptions_max_'.$i);
			$data['flatoptions_min_item_'.$i] = $this->config->get('flatoptions_min_item_'.$i);
			$data['flatoptions_max_item_'.$i] = $this->config->get('flatoptions_max_item_'.$i);
			$data['flatoptions_min_weight_'.$i] = $this->config->get('flatoptions_min_weight_'.$i);
			$data['flatoptions_max_weight_'.$i] = $this->config->get('flatoptions_max_weight_'.$i);
			$data['flatoptions_cost_'.$i] = $this->config->get('flatoptions_cost_'.$i);
			$data['flatoptions_tax_class_id_'.$i] = $this->config->get('flatoptions_tax_class_id_'.$i);
			$data['flatoptions_geo_zone_id_'.$i] = $this->config->get('flatoptions_geo_zone_id_'.$i);
			$data['flatoptions_enabled_'.$i] = $this->config->get('flatoptions_enabled_'.$i);
			$data['flatoptions_order_'.$i] = $this->config->get('flatoptions_order_'.$i);
			foreach($data['languages'] as $languages){
				$data['flatoptions_title_'.$languages['language_id'].'_'.$i] = $this->config->get('flatoptions_title_'.$languages['language_id'].'_'.$i);
			}
		}	
		
		$this->load->model('localisation/tax_class');		
		$data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();		
		$this->load->model('localisation/geo_zone');		
		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		$data['weight_unit']= $this->weight->getUnit($this->config->get('config_weight_class_id'));
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('shipping/flatoptions.tpl', $data));
	}
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/free')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		return !$this->error;
	}
}
?>