<?php
class ModelToolHTMLEmail extends Model {
	
	public function getHTMLEmail($language_id, $main_title, $main_message, $source_type = 'text'){

		$this->load->model('tool/image');
		
		if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
			$server = HTTPS_CATALOG;
		} else {
			$server = HTTP_CATALOG;
		}
		
		// page
		$data['html_email_page_bg'] = $this->config->get('html_email_page_bg');
		
		// top bar
		$data['html_email_top_bar_bg'] = $this->config->get('html_email_top_bar_bg');
		$data['html_email_top_bar_text_color'] = $this->config->get('html_email_top_bar_text_color');
		$data['html_email_top_bar_link_color'] = $this->config->get('html_email_top_bar_link_color');
		
		// header
		$data['html_email_header_bg'] = $this->config->get('html_email_header_bg');
		
		// featured
		$data['html_email_featured_bg'] = $this->config->get('html_email_featured_bg');
		$data['html_email_featured_text_color'] = $this->config->get('html_email_featured_text_color');
		$data['html_email_featured_link_color'] = $this->config->get('html_email_featured_link_color');			
		
		if ($this->config->get('html_email_show_featured')) {
			$data['html_email_featured_corner_bg'] = $this->config->get('html_email_featured_bg');
			$data['html_email_featured_top_bar_bg'] = $this->config->get('html_email_top_bar_bg');
			$data['html_email_featured_header_bg'] = $this->config->get('html_email_header_bg');
			
		} else {
			$data['html_email_featured_corner_bg'] = $this->config->get('html_email_page_bg');
			$data['html_email_featured_top_bar_bg'] = $this->config->get('html_email_page_bg');
			$data['html_email_featured_header_bg'] = $this->config->get('html_email_page_bg');
		}
		
		// main message
		$data['html_email_main_bg'] = $this->config->get('html_email_main_bg');
		$data['html_email_main_text_color'] = $this->config->get('html_email_main_text_color');
		$data['html_email_main_link_color'] = $this->config->get('html_email_main_link_color');			
	
		// footer
		$data['html_email_footer_bg'] = $this->config->get('html_email_footer_bg');
		$data['html_email_footer_text_color'] = $this->config->get('html_email_footer_text_color');
		$data['html_email_footer_link_color'] = $this->config->get('html_email_footer_link_color');					
		
		// subfooter
		$data['html_email_subfooter_bg'] = $this->config->get('html_email_subfooter_bg');
		$data['html_email_subfooter_text_color'] = $this->config->get('html_email_subfooter_text_color');	

		$data['show_featured'] = $this->config->get('html_email_show_featured');
		$data['show_footer'] = $this->config->get('html_email_show_footer');
		
		// GET default texts messages
		$default_words = $this->config->get('html_email_default_word');
		
		if (isset($default_words[$language_id])) { 
			$current_language_word = $default_words[$language_id];
		} else {	
			$current_language_word = $default_words[$this->config->get('config_language_id')];
		}	
			
		$data['featured_title'] = html_entity_decode($current_language_word['featured_title'], ENT_QUOTES, 'UTF-8');
		$data['featured_description'] = html_entity_decode($current_language_word['featured_description'], ENT_QUOTES, 'UTF-8');
		$data['button_find_more_info'] = html_entity_decode($current_language_word['find_more_info'], ENT_QUOTES, 'UTF-8');
		$data['featured_link'] = $current_language_word['featured_link'];
		$data['footer_description'] = html_entity_decode($current_language_word['footer_description'], ENT_QUOTES, 'UTF-8');
		$data['text_view_store'] = html_entity_decode($current_language_word['view_store'], ENT_QUOTES, 'UTF-8');
		$data['text_contact_us'] = html_entity_decode($current_language_word['contact_us'], ENT_QUOTES, 'UTF-8');
		$data['text_my_account'] = html_entity_decode($current_language_word['my_account'], ENT_QUOTES, 'UTF-8');
		$data['copyright'] = html_entity_decode($current_language_word['copyright'], ENT_QUOTES, 'UTF-8');
		
		$data['store_url'] = $server;
		$data['view_store'] = $server;
		$data['contact_us'] = $server . 'index.php?route=information/contact';
		$data['my_account'] = $server . 'index.php?route=account/account';
		
		$data['logo'] = '';
		
		if ($this->config->get('html_email_logo') && file_exists(DIR_IMAGE . $this->config->get('html_email_logo')) && is_file(DIR_IMAGE . $this->config->get('html_email_logo'))) {
			if ($this->config->get('html_email_logo_width') && $this->config->get('html_email_logo_height')) {
				$data['logo'] = $this->model_tool_image->resize($this->config->get('html_email_logo'), $this->config->get('html_email_logo_width'), $this->config->get('html_email_logo_height'));		
			} else {
				$data['logo'] = $server . 'image/' . $this->config->get('html_email_logo');
			}
		}
		
		$data['facebook_link'] = $this->config->get('html_email_fb_link');
		$data['twitter_link'] = $this->config->get('html_email_tw_link');
		$data['youtube_link'] = $this->config->get('html_email_yt_link');
		
		if ($this->config->get('html_email_facebook_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_facebook_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_facebook_icon'))) {
			$data['facebook_icon'] = $server . 'image/' . $this->config->get('html_email_facebook_icon');
		} else {
			$data['facebook_icon'] = '';
		}
		
		if ($this->config->get('html_email_twitter_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_twitter_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_twitter_icon'))) {
			$data['twitter_icon'] = $server . 'image/' . $this->config->get('html_email_twitter_icon');
		} else {
			$data['twitter_icon'] = '';
		}
		
		if ($this->config->get('html_email_youtube_icon') && file_exists(DIR_IMAGE . $this->config->get('html_email_youtube_icon')) && is_file(DIR_IMAGE . $this->config->get('html_email_youtube_icon'))) {
			$data['youtube_icon'] = $server . 'image/' . $this->config->get('html_email_youtube_icon');
		} else {
			$data['youtube_icon'] = '';
		}
		
		$data['main_title'] = html_entity_decode($main_title, ENT_QUOTES, 'UTF-8');  
		
		if ($source_type == 'text') {
			$main_message = $this->text2Html($main_message);
		}
		
		$data['main_message'] = html_entity_decode($main_message, ENT_QUOTES, 'UTF-8');  
		
		$html = $this->load->view('mail/html_email_common.tpl', $data);
		
		return $html;
	}
	
	private function text2Html($message) {
		return str_replace("\n", "<br />", $this->autoLink($message));
	}
	
	private function autoLink($message) {
		return preg_replace('@((https?://)?([-\w]+\.[-\w\.]+)+\w(:\d+)?(/([-\w/_\.]*(\?\S+)?)?)*)@', '<a href="$1">$1</a>', $message);
	}	
}
?>