<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <div class="pull-right">
        <button type="submit" form="form-latest" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
        <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
      <h1><?php echo $heading_title; ?></h1>
      <ul class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
        <?php } ?>
      </ul>
    </div>
  </div>
  <div class="container-fluid">
    <?php if ($error_warning) { ?>
    <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
      <button type="button" class="close" data-dismiss="alert">&times;</button>
    </div>
    <?php } ?>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
      </div>
      <div class="panel-body">
        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-latest" class="form-horizontal">
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-name"><?php echo $entry_name; ?></label>
				<div class="col-sm-10">
				  <input type="text" name="name" value="<?php echo $name; ?>" placeholder="<?php echo $entry_name; ?>" id="input-name" class="form-control" />
				  <?php if ($error_name) { ?>
				  <div class="text-danger"><?php echo $error_name; ?></div>
				  <?php } ?>
				</div>
			</div>
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
				<div class="col-sm-10">
				  <select name="status" id="input-status" class="form-control">
					<?php if ($status) { ?>
					<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
					<option value="0"><?php echo $text_disabled; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_enabled; ?></option>
					<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
					<?php } ?>
				  </select>
				</div>
			</div>
		  
			<ul class="nav nav-tabs" id="languages">
				<?php foreach ($languages as $language) { ?>
				<li><a data-toggle="tab" href="#language-<?php echo $language['language_id']; ?>"><img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" /> <?php echo $language['name']; ?></a></li>
				<?php } ?>
			</ul>
			
			<div class="tab-content">	
				<?php foreach ($languages as $language) { ?>
				<div id="language-<?php echo $language['language_id']; ?>" class="tab-pane">
					<div class="form-group required">
						<label class="col-sm-2 control-label" for="input-title-<?php echo $language['language_id']; ?>"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_title; ?>"><?php echo $entry_title; ?></span></label>
						<div class="col-sm-10">
							<input name="title[<?php echo $language['language_id']; ?>]" placeholder="<?php echo $entry_title; ?>" id="input-title-<?php echo $language['language_id']; ?>" value="<?php echo isset($title[$language['language_id']]) ? $title[$language['language_id']] : ''; ?>" class="form-control" />
							<?php if (isset($error_title[$language['language_id']])) { ?>
							<div class="text-danger"><?php echo $error_title[$language['language_id']]; ?></div>
							<?php } ?>
						</div>
					</div>						
				</div>
				<?php } ?>	
			</div>
			
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-limit"><?php echo $entry_limit; ?></label>
				<div class="col-sm-10">
				  <input type="text" name="limit" value="<?php echo $limit; ?>" placeholder="<?php echo $entry_limit; ?>" id="input-limit" class="form-control" />
				</div>
			</div>
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-width"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_width; ?>"><?php echo $entry_width; ?></span></label>
				<div class="col-sm-10">
				  <input type="text" name="width" value="<?php echo $width; ?>" placeholder="<?php echo $entry_width; ?>" id="input-width" class="form-control" />
				  <?php if ($error_width) { ?>
				  <div class="text-danger"><?php echo $error_width; ?></div>
				  <?php } ?>
				</div>
			</div>
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-height"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_height; ?>"><?php echo $entry_height; ?></span></label>
				<div class="col-sm-10">
				  <input type="text" name="height" value="<?php echo $height; ?>" placeholder="<?php echo $entry_height; ?>" id="input-height" class="form-control" />
				  <?php if ($error_height) { ?>
				  <div class="text-danger"><?php echo $error_height; ?></div>
				  <?php } ?>
				</div>
			</div>
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-display-type"><?php echo $entry_display_type; ?></label>
				<div class="col-sm-10">
				  <select name="display_type" id="input-display-type" class="form-control">
					<?php if ($display_type == "grid") { ?>
					<option value="grid" selected="selected"><?php echo $text_grid; ?></option>
					<option value="list"><?php echo $text_list; ?></option>
					<?php } else { ?>
					<option value="grid"><?php echo $text_grid; ?></option>
					<option value="list" selected="selected"><?php echo $text_list; ?></option>
					<?php } ?>
				  </select>
				</div>
			</div>	
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-random-start"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_random_start; ?>"><?php echo $entry_random_start; ?></span></label>
				<div class="col-sm-10">
				  <select name="random_start" id="input-random-start" class="form-control">
					<?php if ($random_start) { ?>
					<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
					<option value="0"><?php echo $text_disabled; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_enabled; ?></option>
					<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
					<?php } ?>
				  </select>
				</div>
			</div>
			<div class="form-group">
				<label class="col-sm-2 control-label" for="input-auto-slider"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_auto_slider; ?>"><?php echo $entry_auto_slider; ?></span></label>
				<div class="col-sm-10">
				  <select name="auto_slider" id="input-auto-slider" class="form-control">
					<?php if ($auto_slider) { ?>
					<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
					<option value="0"><?php echo $text_disabled; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_enabled; ?></option>
					<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
					<?php } ?>
				  </select>
				</div>
			</div>
			<div class="form-group" id="auto-slider-element">
				<label class="col-sm-2 control-label" for="input-slide-time"><span data-toggle="tooltip" data-html="true" title="<?php echo $help_slide_time; ?>"><?php echo $entry_slide_time; ?></span></label>
				<div class="col-sm-10">
					<div class="input-group">
						<input type="text" name="slide_time" value="<?php echo $slide_time; ?>" placeholder="<?php echo $entry_slide_time; ?>" id="input-slide-time" class="form-control" />
						<span class="input-group-addon"><?php echo $text_seconds; ?></span> 
					</div>	
					<?php if ($error_slide_time) { ?>
					<div class="text-danger"><?php echo $error_slide_time; ?></div>
					<?php } ?>
				</div>
			</div>	  
        </form>
      </div>
    </div>
  </div>
</div>
<script type="text/javascript"><!--
$('select[name=\'auto_slider\']').on('change', function(){
	if ($(this).val() == 1) {
		$('#auto-slider-element').removeClass('hidden');
	} else {
		$('#auto-slider-element').addClass('hidden');
	}
});

$('select[name=\'auto_slider\']').trigger('change');

$('#languages li:first-child a').tab('show');
//--></script>
<?php echo $footer; ?>