<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <div class="pull-right">
        <button type="submit" form="form-banner" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
        <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
      <h1><?php echo $heading_title; ?></h1>
      <ul class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
        <?php } ?>
      </ul>
    </div>
  </div>
  <div class="container-fluid">
    <?php if ($error_warning) { ?>
    <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
      <button type="button" class="close" data-dismiss="alert">&times;</button>
    </div>
    <?php } ?>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
      </div>
      <div class="panel-body">
        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-banner" class="form-horizontal">
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-behaviour"><?php echo $entry_behaviour; ?></label>
            <div class="col-sm-10">
              <select name="order_status_color_behaviour" id="input-behaviour" class="form-control">
                <?php if ($order_status_color_behaviour) { ?>
                <option value="1" selected="selected"><?php echo $text_mark_word; ?></option>
                <option value="0"><?php echo $text_color_cell; ?></option>
                <?php } else { ?>
                <option value="1"><?php echo $text_mark_word; ?></option>
                <option value="0" selected="selected"><?php echo $text_color_cell; ?></option>
                <?php } ?>
              </select>
            </div>
          </div>
          <table id="module" class="table table-striped table-bordered table-hover">
            <thead>
              <tr>
                <td class="text-right">#</td>
                <td class="text-left required"><?php echo $entry_order_status; ?></td>
                <td class="text-left required"><?php echo $entry_background_color; ?></td>
                <td class="text-left required"><?php echo $entry_text_color; ?></td>
                <td></td>
              </tr>
            </thead>
            <tbody>
              <?php $module_row = 1; ?>
              <?php foreach ($modules as $module) { ?>
              <tr id="module-row<?php echo $module_row; ?>">
                <td class="text-right"><?php echo $module_row; ?></td>
                <td class="text-left"><select name="order_status_color_setting[<?php echo $module_row; ?>][order_status_id]" class="form-control">
                    <?php foreach ($order_statuses as $order_status) { ?>
                    <?php if ($order_status['order_status_id'] == $module['order_status_id']) { ?>
                    <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
                    <?php } else { ?>
                    <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
                    <?php } ?>
                    <?php } ?>
                  </select>
				  <?php if (isset($error_order_status_id[$module_row])) { ?>
                  <div class="text-danger"><?php echo $error_order_status_id[$module_row]; ?></div>
                  <?php } ?></td>
                <td class="text-left"><input type="text" name="order_status_color_setting[<?php echo $module_row ?>][background_color]" value="<?php echo $module['background_color']; ?>" placeholder="<?php echo $entry_background_color; ?>" class="form-control colorpicker" />
                  <?php if (isset($error_background_color[$module_row])) { ?>
                  <div class="text-danger"><?php echo $error_background_color[$module_row]; ?></div>
                  <?php } ?></td>
                <td class="text-left"><input type="text" name="order_status_color_setting[<?php echo $module_row ?>][text_color]" value="<?php echo $module['text_color']; ?>" placeholder="<?php echo $entry_text_color; ?>" class="form-control colorpicker" />
                  <?php if (isset($error_text_color[$module_row])) { ?>
                  <div class="text-danger"><?php echo $error_text_color[$module_row]; ?></div>
                  <?php } ?></td>				  
                <td class="text-left"><button type="button" onclick="$('#module-row<?php echo $module_row; ?>').remove();" data-toggle="tooltip" title="<?php echo $button_remove; ?>" class="btn btn-danger"><i class="fa fa-minus-circle"></i></button></td>
              </tr>
              <?php $module_row++; ?>
              <?php } ?>
            </tbody>
            <tfoot>
              <tr>
                <td colspan="4"></td>
                <td class="text-left"><button type="button" onclick="addModule();" data-toggle="tooltip" title="<?php echo $button_module_add; ?>" class="btn btn-primary"><i class="fa fa-plus-circle"></i></button></td>
              </tr>
            </tfoot>
          </table>
        </form>
      </div>
    </div>
  </div>
<script type="text/javascript"><!--
var module_row = <?php echo $module_row; ?>;

initColorPicker();

function addModule() {
	html  = '<tr id="module-row' + module_row + '">';
	html += '  <td class="text-right">' + ($('tbody tr').length + 1) + '</td>';
	html += '  <td class="text-left"><select name="order_status_color_setting[' + module_row + '][order_status_id]" class="form-control">';
	<?php foreach ($order_statuses as $order_status) { ?>
	html += '    <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo addslashes($order_status['name']); ?></option>';
	<?php } ?>
	html += '  </select></td>';
	html += '  <td class="text-left"><div class="inp"><input type="text" name="order_status_color_setting[' + module_row + '][background_color]" value="" placeholder="<?php echo $entry_background_color; ?>" class="form-control colorpicker" /></span></td>'; 
	html += '  <td class="text-left"><input type="text" name="order_status_color_setting[' + module_row + '][text_color]" value="" placeholder="<?php echo $entry_text_color; ?>" class="form-control colorpicker" /></td>'; 
	html += '  <td class="text-left"><button type="button" onclick="$(\'#module-row' + module_row + '\').remove();" data-toggle="tooltip" title="<?php echo $button_remove; ?>" class="btn btn-danger"><i class="fa fa-minus-circle"></i></button></td>';
	html += '</tr>';
	
	$('#module tbody').append(html); 
	
	initColorPicker();
	
	module_row++;
}

function initColorPicker() {
	$('.colorpicker').each(function(){
		$(this).colorpicker();
	});
}
//--></script></div>
<?php echo $footer; ?>