<?php
//----------------------------------------------//
// Multiple Flat Rate Options
// For Opencart v2.x
// Version 2.0 - 2014.10.15
// Copyright 2012 - 2014 Nyco Agung
//----------------------------------------------//
?>
<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <button type="submit" form="form-flat" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
                <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a>
            </div>
            <h1><?php echo $heading_title; ?> v<?php echo $version_no; ?></h1>
            <ul class="breadcrumb">
                <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                    <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                <?php } ?>
            </ul>
		</div>
    </div>
  
  
    <div class="container-fluid">
        <?php if ($error_warning) { ?>
            <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
            	<button type="button" class="close" data-dismiss="alert">&times;</button>
            </div>
        <?php } ?>
        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-flatoptions" class="form-horizontal">
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
            </div>
            <div class="panel-body">
                <div class="form-group">
                    <label class="col-sm-2 control-label" for="input-sort-order"><?php echo $text_custom_title; ?></label>
                    <div class="col-sm-10">
                        <input type="text" name="flatoptions_custom_title" value="<?php echo $flatoptions_custom_title; ?>" placeholder="<?php echo $text_custom_title; ?>" id="input-sort-order" class="form-control" />
                    </div>
                </div>
                <div class="form-group">
                    <label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
                    <div class="col-sm-10">
                        <select name="flatoptions_status" id="input-status" class="form-control">
                        <?php if ($flatoptions_status) { ?>
                            <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                            <option value="0"><?php echo $text_disabled; ?></option>
                        <?php } else { ?>
                            <option value="1"><?php echo $text_enabled; ?></option>
                            <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                        <?php } ?>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <label class="col-sm-2 control-label" for="input-sort-order"><?php echo $entry_sort_order; ?></label>
                    <div class="col-sm-10">
                        <input type="text" name="flatoptions_sort_order" value="<?php echo $flatoptions_sort_order; ?>" placeholder="<?php echo $entry_sort_order; ?>" id="input-sort-order" class="form-control" />
                    </div>
                </div>
            </div>
        </div>
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title"><i class="fa fa-list"></i> <?php echo $instructions; ?></h3>
            </div>
            <div class="panel-body">
            	<div class="table-responsive">
            	<table id="multiple-flat-rate-options" class="table table-bordered table-hover">
                  <thead>
                    <tr>
                      <td class="text-left"><?php echo $entry_title; ?></td>
                      <td class="text-left"><?php echo $entry_condition; ?></td>
                      <td class="text-left"><?php echo $entry_order; ?></td>
                      <td class="text-left"><?php echo $entry_item; ?></td>
                      <td class="text-left"><?php echo $entry_weight; ?></td>
                      <td class="text-left"><?php echo $entry_cost; ?></td>
                      <td class="text-left"><?php echo $entry_tax_class; ?></td>
                      <td class="text-left"><?php echo $entry_geo_zone; ?></td>
                      <td class="text-left"><?php echo $entry_status; ?></td>
                      <td class="text-left"><?php echo $entry_sort_order; ?></td>
                      <td class="text-left">&nbsp;</td>
                    </tr>
                  </thead>
                  <?php for($i=1;$i<=$flatoptions_total;$i++){ ?>
                  <tbody id="multiple-flat-rate-options-row-<?php echo $i; ?>">
                    <tr>
                      <td><?php foreach ($languages as $language) { ?>
                        <div class="padding_2"> <img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" />
                          <input type="text" name="flatoptions_title[<?php echo $language['language_id']; ?>][]" value="<?php echo ${'flatoptions_title_'.$language['language_id'].'_'. $i}; ?>" />
                        </div>
                        <?php } ?></td>
                      <td><select name="flatoptions_condition[]" id="flatoptions_condition_<?php echo $i; ?>" onChange="conditionSelect('<?php echo $i; ?>')">
                          <?php if(${'flatoptions_condition_' . $i} == 'byorder' ) { ?>
                          <option value="byorder" selected="selected"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php }elseif(${'flatoptions_condition_' . $i} == 'byitem' ) { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem" selected="selected"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php }elseif(${'flatoptions_condition_' . $i} == 'byweight' ) { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight" selected="selected"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php }elseif(${'flatoptions_condition_' . $i} == 'byorderitem' ) { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem" selected="selected"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php }elseif(${'flatoptions_condition_' . $i} == 'byorderweight' ) { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight" selected="selected"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php }elseif(${'flatoptions_condition_' . $i} == 'byitemweight' ) { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight" selected="selected"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php } else { ?>
                          <option value="byorder"><?php echo $entry_condition_byorder; ?></option>
                          <option value="byitem"><?php echo $entry_condition_byitem; ?></option>
                          <option value="byweight"><?php echo $entry_condition_byweight; ?></option>
                          <option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>
                          <option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>
                          <option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>
                          <?php } ?>
                        </select></td>
                      <td><?php echo $entry_min; ?>:
                        <input type="text" name="flatoptions_min[]" value="<?php echo ${'flatoptions_min_' . $i}; ?>" size="3" class="number" id="flatoptions_min_<?php echo $i; ?>" />
                        <?php echo $entry_max; ?>:
                        <input type="text" name="flatoptions_max[]" value="<?php echo ${'flatoptions_max_' . $i}; ?>" size="3" class="number" id="flatoptions_max_<?php echo $i; ?>" /></td>
                      <td><?php echo $entry_min; ?>:
                        <input type="text" name="flatoptions_min_item[]" value="<?php echo ${'flatoptions_min_item_' . $i}; ?>" size="3" class="number" id="flatoptions_min_item_<?php echo $i; ?>" />
                        <?php echo $entry_max; ?>:
                        <input type="text" name="flatoptions_max_item[]" value="<?php echo ${'flatoptions_max_item_' . $i}; ?>" size="3" class="number" id="flatoptions_max_item_<?php echo $i; ?>" /></td>
                      <td><?php echo $entry_min; ?>:
                        <input type="text" name="flatoptions_min_weight[]" value="<?php echo ${'flatoptions_min_weight_' . $i}; ?>" size="3" class="number" id="flatoptions_min_weight_<?php echo $i; ?>" />
                        <?php echo $entry_max; ?>:
                        <input type="text" name="flatoptions_max_weight[]" value="<?php echo ${'flatoptions_max_weight_' . $i}; ?>" size="3" class="number" id="flatoptions_max_weight_<?php echo $i; ?>" />
                        <?php echo $weight_unit; ?></td>
                      <td><input type="text" name="flatoptions_cost[]" value="<?php echo ${'flatoptions_cost_' . $i}; ?>" size="4" class="number" /></td>
                      <td><select name="flatoptions_tax_class_id[]">
                          <option value="0"><?php echo $text_none; ?></option>
                          <?php foreach ($tax_classes as $tax_class) { ?>
                          <?php if ($tax_class['tax_class_id'] == ${'flatoptions_tax_class_id_' . $i}) { ?>
                          <option value="<?php echo $tax_class['tax_class_id']; ?>" selected="selected"><?php echo $tax_class['title']; ?></option>
                          <?php } else { ?>
                          <option value="<?php echo $tax_class['tax_class_id']; ?>"><?php echo $tax_class['title']; ?></option>
                          <?php } ?>
                          <?php } ?>
                        </select></td>
                      <td><select name="flatoptions_geo_zone_id[]">
                          <option value="0"><?php echo $text_all_zones; ?></option>
                          <?php foreach ($geo_zones as $geo_zone) { ?>
                          <?php if ($geo_zone['geo_zone_id'] == ${'flatoptions_geo_zone_id_' . $i}) { ?>
                          <option value="<?php echo $geo_zone['geo_zone_id']; ?>" selected="selected"><?php echo $geo_zone['name']; ?></option>
                          <?php } else { ?>
                          <option value="<?php echo $geo_zone['geo_zone_id']; ?>"><?php echo $geo_zone['name']; ?></option>
                          <?php } ?>
                          <?php } ?>
                        </select></td>
                      <td><select name="flatoptions_enabled[]">
                          <?php if (${'flatoptions_enabled_' . $i}) { ?>
                          <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                          <option value="0"><?php echo $text_disabled; ?></option>
                          <?php } else { ?>
                          <option value="1"><?php echo $text_enabled; ?></option>
                          <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                          <?php } ?>
                        </select></td>
                      <td><input type="text" name="flatoptions_order[]" value="<?php echo ${'flatoptions_order_' . $i}; ?>" size="2" class="number" /></td>
                      <td class="text-right"><a onclick="$('#multiple-flat-rate-options-row-<?php echo $i; ?>').remove();" data-toggle="tooltip" title="<?php echo $entry_remove; ?>" class="btn btn-danger" data-original-title="<?php echo $entry_remove; ?>"><i class="fa fa-minus-circle"></i></a></td>
                    </tr>
                  </tbody>
                  <?php } ?>
                  <tfoot>
                    <tr>
                      <td colspan="10"></td>
                      <td class="text-right"><a onclick="addMultipleFlatRate();" class="btn btn-primary" data-toggle="tooltip" data-original-title="<?php echo $entry_add; ?>" title="<?php echo $entry_add; ?>" class="btn btn-success"><i class="fa fa-plus-circle"></i></a></td>
                    </tr>
                  </tfoot>
                </table>
                </div>
            </div>
        </div>
        </form>
        <style type="text/css">
		.number { text-align: right; }
		.padding_2{ margin:2px 0; }
		input[readonly="readonly"] { background-color: #EFEFEF;	}
		</style>
        <script type="text/javascript">
		var multiple_flat_rate_options_row = <?php echo $i; ?>;
		function addMultipleFlatRate() {
			html  = '<tbody id="multiple-flat-rate-options-row-' + multiple_flat_rate_options_row + '">';
			html += '<tr>';
			html += '<td>';
			<?php foreach ($languages as $language) { ?>
				html += '<div class="padding_2">';
				html += '<img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" /> ';
				html += '<input type="text" name="flatoptions_title[<?php echo $language['language_id']; ?>][]" value="Flat Rate ' + multiple_flat_rate_options_row + '" />';
				html += '</div>';
			<?php } ?>
			html += '</td>';
			html += '<td>';
			html += '<select name="flatoptions_condition[]" id="flatoptions_condition_' + multiple_flat_rate_options_row + '" onChange="conditionSelect(' + multiple_flat_rate_options_row + ')">';
			html += '<option value=""><?php echo $entry_condition_pleaseselect; ?></option>';
			html += '<option value="byorder"><?php echo $entry_condition_byorder; ?></option>';
			html += '<option value="byitem"><?php echo $entry_condition_byitem; ?></option>';
			html += '<option value="byweight"><?php echo $entry_condition_byweight; ?></option>';
			html += '<option value="byorderitem"><?php echo $entry_condition_byorderitem; ?></option>';
			html += '<option value="byorderweight"><?php echo $entry_condition_byorderweight; ?></option>';
			html += '<option value="byitemweight"><?php echo $entry_condition_byitemweight; ?></option>';
			html += '</select>';
			html += '</td>';
			html += '<td><?php echo $entry_min; ?>: <input type="text" name="flatoptions_min[]" value="0" size="3" class="number" id="flatoptions_min_' + multiple_flat_rate_options_row + '" /> <?php echo $entry_max; ?>: <input type="text" name="flatoptions_max[]" value="0" size="3" class="number" id="flatoptions_max_' + multiple_flat_rate_options_row + '" /></td>';
			html += '<td><?php echo $entry_min; ?>: <input type="text" name="flatoptions_min_item[]" value="0" size="3" class="number" id="flatoptions_min_item_' + multiple_flat_rate_options_row + '" /> <?php echo $entry_max; ?>: <input type="text" name="flatoptions_max_item[]" value="0" size="3" class="number" id="flatoptions_max_item_' + multiple_flat_rate_options_row + '" /></td>';
			html += '<td><?php echo $entry_min; ?>: <input type="text" name="flatoptions_min_weight[]" value="0" size="3" class="number" id="flatoptions_min_weight_' + multiple_flat_rate_options_row + '" /> <?php echo $entry_max; ?>: <input type="text" name="flatoptions_max_weight[]" value="0" size="3" class="number" id="flatoptions_max_weight_' + multiple_flat_rate_options_row + '" /><?php echo $weight_unit; ?></td>';
			html += '<td><input type="text" name="flatoptions_cost[]" value="0" size="4" class="number" id="_' + multiple_flat_rate_options_row + '" /></td>';
			html += '<td>';
			html += '<select name="flatoptions_tax_class_id[]">';
			html += '<option value="0"><?php echo $text_none; ?></option>';
			<?php foreach ($tax_classes as $tax_class) { ?>
			html += '<option value="<?php echo $tax_class['tax_class_id']; ?>"><?php echo $tax_class['title']; ?></option>';
			<?php } ?>
			html += '</select>';
			html += '</td>';
			html += '<td>';
			html += '<select name="flatoptions_geo_zone_id[]">';
			html += '<option value="0"><?php echo $text_all_zones; ?></option>';
			<?php foreach ($geo_zones as $geo_zone) { ?>
			html += '<option value="<?php echo $geo_zone['geo_zone_id']; ?>"><?php echo $geo_zone['name']; ?></option>';
			<?php } ?>
			html += '</select>';
			html += '</td>';
			html += '<td>';
			html += '<select name="flatoptions_enabled[]">';
			html += '<option value="1"><?php echo $text_enabled; ?></option>';
			html += '<option value="0" selected="selected"><?php echo $text_disabled; ?></option>';
			html += '</select>';
			html += '</td>';
			html += '<td>';
			html += '<input type="text" name="flatoptions_order[]" value="' + multiple_flat_rate_options_row + '" size="2" class="number" />';
			html += '</td>';
			html += '<td class="text-right">';
			html += '<a onclick="$(\'#multiple-flat-rate-options-row-' + multiple_flat_rate_options_row + '\').remove();" data-toggle="tooltip" title="<?php echo $entry_remove; ?>" class="btn btn-danger" data-original-title="<?php echo $entry_remove; ?>"><i class="fa fa-minus-circle"></i></a>';
			html += '</td>';
			html += '</tr>';
			html += '</tbody>';
		
			$('#multiple-flat-rate-options > tfoot').before(html);
			multiple_flat_rate_options_row++;
		}
		function conditionSelect(selectedID){
			var selectedCondition = $('#flatoptions_condition_'+selectedID).val();
			//REMOVE CLASS
			$('#flatoptions_min_'+selectedID).removeClass('disabled');
			$('#flatoptions_max_'+selectedID).removeClass('disabled');
			$('#flatoptions_min_item_'+selectedID).removeClass('disabled');
			$('#flatoptions_max_item_'+selectedID).removeClass('disabled');
			$('#flatoptions_min_weight_'+selectedID).removeClass('disabled');
			$('#flatoptions_max_weight_'+selectedID).removeClass('disabled');
			
			switch(selectedCondition){
				case 'byorder':
					$('#flatoptions_min_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', true).val(0);
					break;
				case 'byitem':
					$('#flatoptions_min_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', true).val(0);
					break;
				case 'byweight':
					$('#flatoptions_min_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', false);
					break;
				case 'byorderitem':
					$('#flatoptions_min_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', true).val(0);
					break;
				case 'byorderweight':
					$('#flatoptions_min_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', false);
					break;	
				case 'byitemweight':
					$('#flatoptions_min_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_max_'+selectedID).attr('readonly', true).val(0);
					$('#flatoptions_min_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_item_'+selectedID).attr('readonly', false);
					$('#flatoptions_min_weight_'+selectedID).attr('readonly', false);
					$('#flatoptions_max_weight_'+selectedID).attr('readonly', false);
					break;		
			}
		}
		$(document).ready(function() {
			for (var i=0;i<<?php echo $i; ?>;i++){
				conditionSelect(i);
			}
		});
		</script> 
    </div>
</div>
<?php echo $footer; ?>
