<?php
class ControllerPaymentZGlobalPay extends Controller {
	public function index() {
		$this->language->load('payment/zglobalpay');

		$data['text_testmode'] = $this->language->get('text_testmode');
		$data['text_tranx_details'] = $this->language->get('text_tranx_details');	
		$data['button_confirm'] = $this->language->get('button_confirm');

		$data['testmode'] = $this->config->get('zglobalpay_test');

		if (!$this->config->get('zglobalpay_test')) {
			$data['action'] = 'https://demo.globalpay.com.ng/globalpay_demo/Paymentgatewaycapture.aspx'; // LIVE Mode
		} else {
			$data['action'] = 'https://demo.globalpay.com.ng/globalpay_demo/Paymentgatewaycapture.aspx'; // Sandbox Mode
		}

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		if ($order_info) {
			
			$data['ref_id'] = $this->session->data['order_id'];
			$data['merchant'] = $this->config->get('zglobalpay_mertid');
		
			$data['item_name'] = html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8');	
				
			//$order_info['total'] = $this->currency->format($order_info['total'], $order_info['currency_code'], false, false);
			$data['amount'] = $order_info['total'] = $this->currency->format($order_info['total'], $order_info['currency_code'], 
									$order_info['currency_value'], false); // modified
			//$zglobalpay_amount = $data['zglobalpay_amount'] = $amount * 100;
		
			$tranx_ref = $data['tranx_ref'] = $this->generateTXRef($data['ref_id']);
			
			$data['currency_code'] = $order_info['currency_code'];
			$data['success'] = $this->url->link('checkout/success');
			$data['cancel'] = $this->url->link('checkout/checkout', '', 'SSL');
			$notify_url = $data['callback'] = $this->url->link('payment/zglobalpay/callback', '', 'SSL');

			$data['custom'] = $this->session->data['order_id'];


			/****************************/
			if(empty($this->session->data['customer_id']))
			{
				$bname=$this->session->data['guest']['firstname'];
				$bemail=$this->session->data['guest']['email'];
				$data['cust_id'] =$this->session->data['guest']['email'] ;				
				$data['cust_name'] = $this->session->data['guest']['firstname']." ".$this->session->data['guest']['lastname'];
				//@$this->data['cust_id'] =$this->session->data['guest']['id'] ;
			}
			else
			{
				$data['first_name'] = html_entity_decode($order_info['payment_firstname'], ENT_QUOTES, 'UTF-8');	
				$data['last_name'] = html_entity_decode($order_info['payment_lastname'], ENT_QUOTES, 'UTF-8');			
				$data['email'] = $order_info['email'];
	
				$data['cust_id'] = $data['email'];
				$data['cust_name'] = $data['first_name'] . ' ' . $data['last_name'];	
			}			
			
			//$data['hash'] = $this->generate_hash($tranx_ref,$zglobalpay_amount,$notify_url);
			
			if (!$this->config->get('zglobalpay_test')) 
			{
        		$endpoint = "https://demo.globalpay.com.ng/GlobalpayWebService_demo/service.asmx";
			} else {
				$endpoint = "https://demo.globalpay.com.ng/GlobalpayWebService_demo/service.asmx";
			}			

			$data['products'] = array();

			foreach ($this->cart->getProducts() as $product) {
				
				$option_data = array();

				foreach ($product['option'] as $option) {
					if ($option['type'] != 'file') {
						$value = $option['option_value'];	
					} else {
						$filename = $this->encryption->decrypt($option['option_value']);
						$value = utf8_substr($filename, 0, utf8_strrpos($filename, '.'));
					}									

					$option_data[] = array(
						'name'  => $option['name'],
						'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
					);
				}
				
				$data['products'][] = array(
					'name'     => $product['name'],
					'model'    => $product['model'],
					'quantity' => $product['quantity'],
					'option'   => $option_data,
					'price'    => $this->currency->format($product['price'], $data['currency_code'], false, false)
				);
			}

			$products = '';
			
			foreach ($this->cart->getProducts() as $product) {
				$products .= $product['quantity'] . ' x ' . $product['name'] . ', ';
			}		
			
			$data['tranx_memo'] = 'Purchase: ' . $products;
			
			$data['discount'] = 0;

			$total = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), $data['currency_code'], false, false);

			if ($total > 0) {
				$data['products'][] = array(
					'name'     => $this->language->get('text_total'),
					'model'    => '',
					'quantity' => 1,
					'price'    => $total
				);	
			} else {
				$data['discount'] -= $total;
			}

			if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
				$data['base'] = $this->config->get('config_ssl');
			} else {
				$data['base'] = $this->config->get('config_url');
			}
							
			$tranx_addon["StoreName"] = $this->config->get('config_name');
			$tranx_addon["TranxMemo"] = $data['tranx_memo'];
			$tranx_addon["ShopperIP"] = $order_info['ip']; //$this->get_client_ip();

			$tranx_meta = @json_encode($tranx_addon); // StoreName, TranxMemo, ShopperIP


			// Update Tranx ID where Order ID
			@$sqlup = "UPDATE `" . DB_PREFIX . "order` SET tranx_id = '" . $tranx_ref . "' 
							WHERE order_id = '" . (int)$data['ref_id'] . "'";
			//$this->db->query($sqlup);
														
			// Insert Transaction Record
			@$sqlin = "INSERT IGNORE INTO `". DB_PREFIX ."zglobalpay_tranxlog`
			(order_id,cust_name,email,tranx_id,tranx_date,tranx_meta,amount,currency,status) VALUES
			('".$data['ref_id']."','".$data['cust_name']."','".$data['cust_id']."','".$tranx_ref."',NOW(),'".
			$tranx_meta."','".$amount."','".$data['currency_code']."','Pending')";  // time()
			//$this->db->query($sqlin);

			$mail_body="<table cellspacing='0' cellpadding='5' border='0' width='80%' align='center'><tr><td style='background-color:#1460A4;color:white;font-weight:bold;'>Zenith GlobalPay Transaction</td></tr><tr><td  style='border:2px solid #1460A4; padding:5px;'>Dear  ".$data['cust_name'].",<p>Please find below the details of the order:<p>Order ID: ".$data['ref_id']."<p>Transaction ID: ".$tranx_ref."<p>Please note this ID as it may be used to track your payment.<p>Best Regards<br>".$tranx_addon["StoreName"] ."</td></tr></table>";
			
			$cust_email = $data['cust_id'];

			//$this->config->get('config_name'); // store name
			//$this->config->get('config_title'); // store title
			//$this->config->get('config_owner'); // store owner name
			//$this->config->get('config_email'); // store email

			$headers  = "MIME-Version: 1.0\r\n";
			$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
			$headers .= "From: " . $this->config->get('config_name') . "<". 
									$this->config->get('config_email') . ">\r\n";
			$headers .= "Reply-To: \r\n";
			$headers .= "Cc: \r\n";			
			
			/* and now mail it */
			//@mail($cust_email, 'Zenith GlobalPay Payment Notification', $mail_body, $headers);
						
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/zglobalpay.tpl')) {
				return $this->load->view($this->config->get('config_template') . '/template/payment/zglobalpay.tpl', $data);
			} else {
				return $this->load->view('default/template/payment/zglobalpay.tpl', $data);
			}
		}
	}

	public function callback() {

		restore_error_handler();	
		$this->log->write($_SERVER['REQUEST_URI']);
		
		$pdata = @json_encode($_REQUEST);	print_r($pdata);	//print_r($_REQUEST);	
	
		error_reporting (E_ALL ^ E_DEPRECATED);
		ini_set ('soap.wsdl_cache_enabled', 0);
		include('zglobalpay_lib/nusoap.php');
		
		if (!$this->config->get('zglobalpay_test')) 
		{
			$wsdl = "https://demo.globalpay.com.ng/GlobalpayWebService_demo/service.asmx?wsdl";
			$soapaction = "http://www.eazypaynigeria.com/globalpay_demo/getTransactions";
			$namespace = "http://www.eazypaynigeria.com/globalpay_demo/";
		} else {
			$wsdl = "https://demo.globalpay.com.ng/GlobalpayWebService_demo/service.asmx?wsdl";
			$soapaction = "http://www.eazypaynigeria.com/globalpay_demo/getTransactions";
			$namespace = "http://www.eazypaynigeria.com/globalpay_demo/";
		}
		
		$client = new nusoap_client('https://demo.globalpay.com.ng/GlobalpayWebService_demo/service.asmx?wsdl', true);
		$client->soap_defencoding = 'UTF-8';
			
		$merch_txnref = htmlentities($_GET["txnref"]); 
		$channel = "" ; 
		$merchantID = $this->config->get('zglobalpay_mertid'); 
		$start_date = ""; 
		$end_date = ""; 
		$uid = "gl_ws_user"; 
		$pwd = "gl_ws_password"; 
		$payment_status = ""; 
		
		$err = $client->getError();
		
		if ($err) {
			echo '<h2>Constructor error</h2><pre>' . $err . '</pre>';
			return $err;
		}
		// Doc/lit parameters get wrapped
		$MethodToCall= "getTransactions";
		//$MethodToCall= "Checkcenter";
		
		$param = array(
			'merch_txnref' => $merch_txnref, 
			'channel' => $channel,
			'merchantID' => $merchantID,
			'start_date' => $start_date,
			'end_date' => $end_date,
			'uid' => $uid,
			'pwd' => $pwd,
			'payment_status' => $payment_status
		);
		
		print_r($param);
	
		$result = $client->call(
			'getTransactions', 
			array('parameters' => $param),
			$namespace, 
			$soapaction, 
			false,  
			true
		);
	
		// Check for a fault
		if ($client->fault) {
			echo '<h2>Fault</h2><pre>';
			print_r($result);
			echo '</pre>';
			return $result;
		} 
		else {
			// Check for errors
			$err = $client->getError();
		
			if ($err) {
				// Display the error
				echo '<h2>Error</h2><pre>' . $err . '</pre>';
				return $err;
			} 
			else {
				//This gives getTransactionsResult
				$WebResult=$MethodToCall."Result";
				// Pass the result into XML
				$xml = simplexml_load_string($result[$WebResult]);
				//echo $xml;
				
				$amount = $xml->record->amount;
				$txn_date = $xml->record->payment_date;
				$pmt_method = $xml->record->channel;
				$pmt_status = $xml->record->payment_status;
				$pmt_txnref = $xml->record->txnref;
				$currency = $xml->record->field_values->field_values->field[2]->currency;
			   // $pnr = 'PNR';
				$trans_status = $xml->record->payment_status_description;
			}
				
	
			  //Get information from your database
			 //$merch_amt = 
			 //$merch_name = 
			 //$merch_phoneno  =

			 //////////////////////// START FINAL DISPLAY PROCESSING //////////////////////////
			 	
			 //Format and display the necessary parameters including the one above
			  echo "Name : ". $merch_name ;
			  echo "Phone number : ".$merch_phoneno;
			  
			 if ($pmt_status == 'successful')
			 {
				if ($amount == $merch_amt)
				{
					echo "Amount : ". $amount ;
					echo "Transaction Date : ".$txn_date;
					echo "Payment Method : ".$pmt_method;
					echo "Payment Status : ".$pmt_status;
					echo "Transaction Reference Number : ".$pmt_txnref;
					echo "Currency : ".$currency;
					echo "Transaction Status : ".$trans_status;
				}
				else
				{
					echo "Transaction Amount : ".$merch_amt;
					echo "Debited Amount : ". $amount ;
					echo "Transaction Date : ".$txn_date;
					echo "Payment Method : ".$pmt_method;
					echo "Payment Status : ".$pmt_status. " ( Amount does not match and no service will be rendered)";
					echo "Transaction Reference Number : ".$pmt_txnref;
					echo "Currency : ".$currency;
					echo "Transaction Status : ".$trans_status;
				}
				
			 }       
			 else
			 {
				   if ($pmt_status == 'pending')
				   {
						//Please display a message telling the user to check back at a later time. 
						//You should have a background agent that will query globalpay web service intermittently to update the transactions on your site.
						echo "Amount : ". $amount ;
						echo "Transaction Date : ".$txn_date;
						echo "Payment Method : ".$pmt_method;
						echo "Payment Status : ".$pmt_status;
						echo "Transaction Reference Number : ".$pmt_txnref;
						echo "Currency : ".$currency;
						echo "Transaction Status : ".$trans_status;
				   }
				   else
				   {
						echo "Amount : ". $amount ;
						echo "Transaction Date : ".$txn_date;
						echo "Payment Method : ".$pmt_method;
						echo "Payment Status : ".$pmt_status;
						echo "Transaction Reference Number : ".$pmt_txnref;
						echo "Currency : ".$currency;
						echo "Transaction Status : ".$trans_status;
				   }
					
			 }
			 
			 //////////////////////// END FINAL DISPLAY PROCESSING //////////////////////////
				
		
	}
		
		$tranx_ref = htmlentities($_POST['zglobalpay_tranx_id']);
		$query = $this->db->query("SELECT order_id,cust_name,email FROM  
								`" . DB_PREFIX . "zglobalpay_tranxlog` WHERE tranx_id='".$tranx_ref."'");
		$order_id = $query->row["order_id"]; 	$cust_name = $query->row["cust_name"];  $cust_email = $query->row["email"];		

		if (isset($this->request->post['zglobalpay_echo_data']) && $order_id === $this->request->post['zglobalpay_echo_data']) {
			$order_id = $this->request->post['zglobalpay_echo_data'];
		} else {
			$order_id = 0;
		}
		
		exit();
				
		// Start Processing			
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($order_id);

		if (!$order_info) {
			$this->session->data['error'] = $this->language->get('error_no_order');
			$this->redirect($this->url->link('checkout/cart'));
		}
			
		if ($order_info) {
			if ($this->config->get('zglobalpay_debug')) {
				$this->log->write('ZGLOBALPAY :: CALLBACK DATA: ' . print_r($this->request->post, true));
			}

			$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "zglobalpay_tranxlog` WHERE order_id='".$order_id."'");
			$amount = $query->row["amount"];
			$amount = round($amount) * 100; 
					
			
			if (@$this->request->post['zglobalpay_gway_name'] == 'webpay') {
				// Fraud Verification Step >> Get Accurate Response Codes via Requery from WebPay
				$rsp = $this->get_transaction_status($tranx_ref, $amount);
				$raw_response = json_encode($rsp, true);
				//print_r($rsp);
	
				$rsp_code = $rsp['ResponseCode'];				
				$rsp_desc = $rsp['ResponseDescription'];				
				$gway_amount = $rsp['Amount'] / 100;
				
				$rspdesc = $this->get_response_codes($rsp_code);
				
			} // End WebPAY confirmation
			else {
				$decode = json_decode($pdata, true);
				$rsp_code = $decode["zglobalpay_tranx_status_code"];
				$rsp_desc = trim($decode["zglobalpay_tranx_status_msg"]);	
				$rspdesc = $this->get_response_codes($rsp_code);
			}

				//$response = $rsp_code . " - " . $rsp_desc;
				$amount = $xml->record->amount;
				$txn_date = $xml->record->payment_date;
				$pmt_method = $xml->record->channel;
				$pmt_status = $xml->record->payment_status;
				$pmt_txnref = $xml->record->txnref;
				$currency = $xml->record->field_values->field_values->field[2]->currency;
			   // $pnr = 'PNR';
				$trans_status = $xml->record->payment_status_description;
										
			// Process according to gateway response
			if (isset($pmt_status)) {
				$order_status_id = $this->config->get('config_order_status_id');
				
				if (!empty($rsp_desc)) {
							@$gway_msg = $rsp_desc;
				} else {	@$gway_msg = $rspdesc[$rsp_code];	}
				
				$total = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

				$db_amount = $total * 100;
				$gway_amount = (float)$amount;
				$epsilon = 0.00001; # machine epsilon/unit-roundoff/precision			
								
				$msg = '';

				switch($pmt_status) {
					case 'successful': // Successful
						if(abs($gway_amount - $db_amount) < $epsilon) { // comparing floats
							$order_status_id = $this->config->get('zglobalpay_completed_status_id');
							$msg .= "Thank you for shopping with us. Your Transaction was <b>SUCCESSFUL</b>.
							<br/><br/>
							<b>Order ID:</b> $order_id<br/>
							<b>Transaction ID:</b> $tranx_ref";
							$tranx_success = 1;
							$status = 'Successful';
						} else { // Successful BUT Amount Mismatch
							$order_status_id = $this->config->get('zglobalpay_denied_status_id');
							$this->log->write('Zenith GlobalPay :: Transaction Amount Mismatch! ' . $gway_amt);
							$msg .= "Thank you for shopping with us. However, the Transaction was <b>UNSUCCESSFUL</b>.
							<br/><br />
							<b>Reason:</b> Transaction Amount Mismatch. Please contact 
							<a href='mailto:support@sizzelle.com'>support@sizzelle.com</a> 
							for more details.  <br/>
							<b>Order ID:</b> $order_id <br/>
							<b>Transaction ID:</b> $tranx_ref";
							$status = 'Failed';
						}
						break;
					case 'pending': // Failed -  Incomplete Transaction
							$rsp_desc = $gway_msg = $rspdesc;
							$order_status_id = $this->config->get('zglobalpay_failed_status_id');
							$msg .= "Thank you for shopping with us. However, the Transaction was <b>UNSUCCESSFUL</b>.
							<br/><br/>
							<b>Reason:</b> $gway_msg<br/>
							<b>Order ID:</b> $order_id<br/>
							<b>Transaction ID:</b> $tranx_ref";
							$status = 'Failed';
						break;	
					case 'failed': // Failed -  Incomplete Transaction
							$rsp_desc = $gway_msg = $rspdesc;
							$order_status_id = $this->config->get('zglobalpay_failed_status_id');
							$msg .= "Thank you for shopping with us. However, the Transaction was <b>UNSUCCESSFUL</b>.
							<br/><br/>
							<b>Reason:</b> $gway_msg<br/>
							<b>Order ID:</b> $order_id<br/>
							<b>Transaction ID:</b> $tranx_ref";
							$status = 'Failed';
						break;																					
					default: // Failed
							$order_status_id = $this->config->get('zglobalpay_failed_status_id');
							$msg .= "Thank you for shopping with us. However, the Transaction was <b>UNSUCCESSFUL</b>.
							<br/><br />
							<b>Reason:</b> $gway_msg<br/>
							<b>Order ID:</b> $order_id<br/>
							<b>Transaction ID:</b> $tranx_ref";
							$status = 'Failed';
						break;															
				}

			}		

				$response = $rsp_code . " - " . $rsp_desc;
				
				$StoreName = $this->config->get('config_name');
				$ip = $this->get_client_ip();
				
				$rsp_data = array();
				$rsp_data = array(
					'capture_status' => 1,
					'raw_response' => $pdata,
					'response' => $response,
					'status' => $status,
					'last_date_modified' => date( "Y-m-d H:i:s", strtotime("now")),
					'last_ip_modified' => $ip
				);
				
				//print_r($rsp_data);	print_r($order_info);	echo $msg;
				
				// Update Transactions Log [ `" . DB_PREFIX . "zglobalpay_tranxlog` ]				
				$sql = "UPDATE `" . DB_PREFIX . "zglobalpay_tranxlog` SET capture_status='1', raw_response='".$pdata."',
				response='".($response)."', status='".($status)."', last_date_modified=NOW(), last_ip_modified='".$ip."'
				WHERE  order_id='".$order_id."'";	// WHERE tranx_id='".$tranx_ref."'";
				$this->db->query($sql);
								
				$mail_body = "<table cellspacing='0' cellpadding='5' border='0' width='80%' align='center'><tr><td style='background-color:#1460A4;color:white;font-weight:bold;padding-left:5px;'>Zenith GlobalPay Transaction - Payment Confirmation</td></tr><tr><td  style='border:2px solid #1460A4; padding:5px;'>Thank you ".$cust_name." for your purchase. <p></p> Please find below your transaction details:<p></p>Order ID: ".$order_id."<br/>Transaction ID: ".$tranx_ref."<br/>Payment Status: ".$status."<br/>Gateway Response: ".$response."<p></p>Best Regards<br/>". $StoreName ."</td></tr></table>";

				$headers  = "MIME-Version: 1.0\r\n";
				$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
				$headers .= "From: " . $this->config->get('config_name') . "<". 
										$this->config->get('config_email') . ">\r\n";
				$headers .= "Reply-To: \r\n";
				$headers .= "Cc: \r\n";
				
				/* and now mail it */
				@mail($cust_email, 'Zenith GlobalPay Payment Notification', $mail_body, $headers);
												
			if (@$tranx_success == 1) {

				//$this->session->data['order_id2'] = $order_id;
				//$this->session->data['gway_tranx_id'] = $tranx_ref;
				//$this->redirect($this->url->link('checkout/success'));
				
				$order_status_id = $this->config->get('zglobalpay_completed_status_id');
				$this->model_checkout_order->addOrderHistory($order_id, $order_status_id, $msg, false);
					
				// Since it returned, the customer should see success.
				// It's up to the store owner to manually verify payment.
				$this->response->redirect($this->url->link('checkout/success', '', 'SSL'));
						
				/*
				$data['heading_title'] = $this->language->get('order_success');
    			$data['text_message'] = "<div class='warning'><p style='padding-left:20px;'>$msg</p> </div>";
								
				$data['continue'] = $this->url->link('checkout/success');

				$data['column_left'] = $this->load->controller('common/column_left');
				$data['column_right'] = $this->load->controller('common/column_right');
				$data['content_top'] = $this->load->controller('common/content_top');
				$data['content_bottom'] = $this->load->controller('common/content_bottom');
				$data['footer'] = $this->load->controller('common/footer');
				$data['header'] = $this->load->controller('common/header');

				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/success.tpl')) {
					$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/common/success.tpl', $data));
				} else {
					$this->response->setOutput($this->load->view('default/template/common/success.tpl', $data));
				}}*/
								
			} else {

				//$this->language->load('checkout/success');
				$this->language->load('payment/zglobalpay');
				
				$this->document->setTitle($this->language->get('heading_title'));

				$data['breadcrumbs'] = array();
	
				$data['breadcrumbs'][] = array(
					'text' => $this->language->get('text_home'),
					'href' => $this->url->link('common/home')
				);
	
				$data['breadcrumbs'][] = array(
					'text' => $this->language->get('text_basket'),
					'href' => $this->url->link('checkout/cart')
				);
	
				$data['breadcrumbs'][] = array(
					'text' => $this->language->get('text_checkout'),
					'href' => $this->url->link('checkout/checkout', '', 'SSL')
				);
												
				$data['heading_title'] = sprintf($this->language->get('order_failure'), $this->config->get('config_name'));			
    			$data['text_message'] = "<div class='attention'><p style='padding-left:20px;'>$msg</p> </div>";
				
    			$data['button_continue'] = $this->language->get('button_continue');
				//$data['fail_continue'] = $this->url->link('checkout/checkout', '', 'SSL');
				//$data['continue'] = $this->url->link('account/order/info', 'order_id=' . $order_id, 'SSL');				
 				$data['continue'] = $this->url->link('checkout/checkout');

				$data['column_left'] = $this->load->controller('common/column_left');
				$data['column_right'] = $this->load->controller('common/column_right');
				$data['content_top'] = $this->load->controller('common/content_top');
				$data['content_bottom'] = $this->load->controller('common/content_bottom');
				$data['footer'] = $this->load->controller('common/footer');
				$data['header'] = $this->load->controller('common/header');

				$order_status_id = $this->config->get('zglobalpay_failed_status_id');
				$this->model_checkout_order->addOrderHistory($order_id, $order_status_id, $msg, false);
				
				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/success.tpl')) {
					$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/common/success.tpl', $data));
				} else {
					$this->response->setOutput($this->load->view('default/template/common/success.tpl', $data));
				}
				
			}
					
		}
	}
	
	protected function get_transaction_status($txnref, $amount) {
		$return = false;
		
		$gtmertid = $this->config->get('zglobalpay_mertid');
		$hash = $this->generate_hash2($txnref);
		
		if ( 'yes' == $this->testmode ) {
			$endpoint = "https://ibank.gtbank.com/GlobalPayService/gettransactionstatus.json";
		} else {
			$endpoint = "https://ibank.gtbank.com/GlobalPayService/gettransactionstatus.json";
		}
	
		$endpoint .= "?mertid=$gtmertid&amount=$amount&tranxid=$txnref&hash=$hash" ;

		set_time_limit(0);
		$ch = curl_init($endpoint);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		//curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);	
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);				
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 120);
		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
		curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
		
		$output = curl_exec($ch);
			
		if (curl_error($ch)) {
			echo 'CURL ERROR: ' . curl_errno($ch) . '::' . curl_error($ch);
			if ($this->config->get('zglobalpay_debug')) {
				$this->log->write('ZGLOBALPAY CURL ERROR: ' . curl_errno($ch) . '::' . curl_error($ch));
			}
		} elseif ($output) {
			$last_url = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);
			if ($last_url) {
				if ($url = parse_url($last_url)) {
					if ($pairs = explode('&', $url['query'])) {
						foreach ($pairs as $i=>$pair) {
							$kv = explode('=', $pair);
							
							$_GET[$kv[0]] = $kv[1];
							$_REQUEST[$kv[0]] = $kv[1];
							
							if ($kv[0] == 'resp') {
								if ($kv[1] == '00') {
									$return = true;
								}
							}
						}
					}
				}
			}
			curl_close($ch);
			
			$response = json_decode($output, true);
			//print_r($response);
		}
		return $response;
	}	
		
	protected function generateTXRef($id){
		$rx = mt_rand(10,99);
		$ref = $id.str_shuffle(date("ymdHis").$rx); // Transaction ID
		return $ref;
	}

	// generate_hash
	protected function generate_hash($txnref,$total,$notify_url){ // $zglobalpay_hash_key
		//zglobalpay_tranx_id + zglobalpay_tranx_amt + zglobalpay_tranx_noti_url + hashkey				
		$hash_string = $txnref.$total.$notify_url.$this->config->get('zglobalpay_hash_key');
		$hash = hash('sha512', $hash_string);
		return $hash;
	}
	
	// generate_hash (requery)
	protected function generate_hash2($txnref){		
		//mertid + tranxid + hashkey				
		$hash_string = $this->config->get('zglobalpay_mertid').$txnref.$this->config->get('zglobalpay_hash_key');
		$hash = hash('sha512', $hash_string);
		return $hash;
	}

	public function getAmount($tranx_id) {
		$query = 
		$this->db->query("SELECT * FROM `". DB_PREFIX ."order` WHERE tranx_id = '" . $tranx_id . "' LIMIT 1");
		return $query->rows;
	}

	// Get Client IP
	function get_client_ip()
	{
		$ipaddress = '';
		if (getenv('HTTP_CLIENT_IP'))
		  $ipaddress = getenv('HTTP_CLIENT_IP');
		else if(getenv('HTTP_X_FORWARDED_FOR'))
		  $ipaddress = getenv('HTTP_X_FORWARDED_FOR');
		else if(getenv('HTTP_X_FORWARDED'))
		  $ipaddress = getenv('HTTP_X_FORWARDED');
		else if(getenv('HTTP_FORWARDED_FOR'))
		  $ipaddress = getenv('HTTP_FORWARDED_FOR');
		else if(getenv('HTTP_FORWARDED'))
		  $ipaddress = getenv('HTTP_FORWARDED');
		else if(getenv('REMOTE_ADDR'))
		  $ipaddress = getenv('REMOTE_ADDR');
		else
		  $ipaddress = 'UNKNOWN';
		
		return $ipaddress;
	}
			
	public function get_response_codes($rsp_code) {
			$statuses = array(
				 '00'=>'Approved by Financial Institution'
				,'01'=>'Refer to Financial Institution'
				,'02'=>'Refer to Financial Institution, Special Condition'
				,'03'=>'Invalid Merchant'
				,'04'=>'Pick-up card'
				,'05'=>'Do Not Honor'
				,'06'=>'Error'
				,'07'=>'Pick-Up Card, Special Condition'
				,'08'=>'Honor with Identification'
				,'09'=>'Request in Progress'
				,'10'=>'Approved by Financial Institution, Partial'
				,'11'=>'Approved by Financial Institution, VIP'
				,'12'=>'Invalid Transaction'
				,'13'=>'Invalid Amount'
				,'14'=>'Invalid Card Number'
				,'15'=>'No Such Financial Institution'
				,'16'=>'Approved by Financial Institution, Update Track 3'
				,'17'=>'Customer Cancellation'
				,'18'=>'Customer Dispute'
				,'19'=>'Re-enter Transaction'
				,'20'=>'Invalid Response from Financial Institution'
				,'21'=>'No Action Taken by Financial Institution'
				,'22'=>'Suspected Malfunction'
				,'23'=>'Unacceptable Transaction Fee'
				,'24'=>'File Update not Supported'
				,'25'=>'Unable to Locate Record'
				,'26'=>'Duplicate Record'
				,'27'=>'File Update Field Edit Error'
				,'28'=>'File Update File Locked'
				,'29'=>'File Update Failed'
				,'30'=>'Format Error'
				,'31'=>'Bank Not Supported'
				,'32'=>'Completed Partially by Financial Institution'
				,'33'=>'Expired Card, Pick-Up'
				,'34'=>'Suspected Fraud, Pick-Up'
				,'35'=>'Contact Acquirer, Pick-Up'
				,'36'=>'Restricted Card, Pick-Up'
				,'37'=>'Call Acquirer Security, Pick-Up'
				,'38'=>'PIN Tries Exceeded, Pick-Up'
				,'39'=>'No Credit Account'
				,'40'=>'Function not Supported'
				,'41'=>'Lost Card, Pick-Up'
				,'42'=>'No Universal Account'
				,'43'=>'Stolen Card, Pick-Up'
				,'44'=>'No Investment Account'
				,'51'=>'Insufficient Funds'
				,'52'=>'No Check Account'
				,'53'=>'No Savings Account'
				,'54'=>'Expired Card'
				,'55'=>'Incorrect PIN'
				,'56'=>'No Card Record'
				,'57'=>'Transaction not permitted to Cardholder'
				,'58'=>'Transaction not permitted on Terminal'
				,'59'=>'Suspected Fraud'
				,'60'=>'Contact Acquirer'
				,'61'=>'Exceeds Withdrawal Limit'
				,'62'=>'Restricted Card'
				,'63'=>'Security Violation'
				,'64'=>'Original Amount Incorrect'
				,'65'=>'Exceeds withdrawal frequency'
				,'66'=>'Call Acquirer Security'
				,'67'=>'Hard Capture'
				,'68'=>'Response Received Too Late'
				,'75'=>'PIN tries exceeded'
				,'76'=>'Reserved for Future Postilion Use'
				,'77'=>'Intervene, Bank Approval Required'
				,'78'=>'Intervene, Bank Approval Required for Partial Amount'
				,'90'=>'Cut-off in Progress'
				,'91'=>'Issuer or Switch Inoperative'
				,'92'=>'Routing Error'
				,'93'=>'Violation of law'
				,'94'=>'Duplicate Transaction'
				,'95'=>'Reconcile Error'
				,'96'=>'System Malfunction'
				,'98'=>'Exceeds Cash Limit'
				,'A0'=>'Unexpected error'
				,'A4'=>'Transaction not permitted to card holder, via channels'
				,'Z0'=>'Transaction Status Unconfirmed'
				,'Z1'=>'Transaction Error'
				,'Z2'=>'Bank account error'
				,'Z3'=>'Bank collections account error'
				,'Z4'=>'Interface Integration Error'
				,'Z5'=>'Duplicate Reference Error'
				,'Z6'=>'Incomplete Transaction'
				,'Z7'=>'Transaction Split Pre-processing Error'
				,'Z8'=>'Invalid Card Number, via channels'
				,'Z9'=>'Transaction not permitted to card holder, via channels'
				
				,'X00'=>'Account error, please contact your bank'
				,'X03'=>'The amount requested is above the limit permitted by your bank, please contact your bank'
				,'X04'=>'The amount requested is too low'
				,'X05'=>'The amount requested is above the limit permitted by your bank, please contact your bank'
				
				,'10001'=>'Incomplete Transaction/User Cancelled'
				,'10004'=>'User Cancelled'
				,'20053'=>'Data Verification Failed'
				,'70035'=>'You have not been set up to make this call'
				,'70038'=>'Missing Header'				

			);
			
			// return					  		
			return (isset($statuses[$rsp_code])) ? $statuses[$rsp_code] : 'Unknown Error';
			
		}
		
		// Add New Order to Zenith GlobalPay Transactions Log Table
		function add_gtorder($order_id, $zglobalpay_args) {

		}

					
		// Update  Transactions Log Table
		function update_gtorder($order_id, $tranx_id, $rsp_data) {

		$sql = "UPDATE `" . DB_PREFIX . "zglobalpay_tranxlog` SET capture_status='1', raw_response='".$pdata."',
				status='".($status)."', response='".($rsp_code)."', last_date_modified=NOW(), last_ip_modified='".$pdata."'
				WHERE  order_id='".$order_id."'";	// WHERE tranx_id='".$tranx_ref."'";
				$this->db->query($sql);
				
		$query = $this->db->query($sql);
		return $query->rows;

		}
				
}