<?php
//----------------------------------------------//
// Multiple Flat Rate Options
// For Opencart v2.x
// Version 2.0 - 2014.10.15
// Copyright 2012 - 2014 Nyco Agung
//----------------------------------------------//

class ModelShippingFlatoptions extends Model {
	function getQuote($address) {
		$this->language->load('shipping/flatoptions');
		//VARIABLES
		$site_language = (int)$this->config->get('config_language_id');
		$method_data = array();
		$quote_data = array();
		$optiondata = array();
		$ingeozone = array();
		$scount = 0;		
		$subTotal = $this->cart->getSubTotal();
		$weightTotal = $this->cart->getWeight();
		$totalItem = $this->cart->countProducts();
		//GET MULTIRATE
		$query_get_total = $this->db->query("SELECT count('key') as total FROM " . DB_PREFIX . "setting as setting WHERE setting.key like 'flatoptions_title_%'");		
		$total_flatrateoptions = $query_get_total->row['total'];
		
		//LOOKUP ZONE TO GEOZONE
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE  country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id =0)");
		
		if($query->rows){ //GET GEOZONES
			foreach ($query->rows as $result) {
				$ingeozone[] = $result['geo_zone_id'];
			}
		}
		
		if($total_flatrateoptions > 0){ //IF FMULTIPLE LAT OPTIONS ENABLED
			for($i=1;$i<=$total_flatrateoptions;$i++){
				if($this->config->get('flatoptions_enabled_'.$i)==1 && (in_array($this->config->get('flatoptions_geo_zone_id_'.$i), $ingeozone) || $this->config->get('flatoptions_geo_zone_id_'.$i) == 0)){
					//GET VALUES
					$minOrder = floatval($this->config->get('flatoptions_min_'.$i));
					$maxOrder = floatval($this->config->get('flatoptions_max_'.$i));
					$minOrderItem = floatval($this->config->get('flatoptions_min_item_'.$i));
					$maxOrderItem = floatval($this->config->get('flatoptions_max_item_'.$i));
					$minOrderWeight = floatval($this->config->get('flatoptions_min_weight_'.$i));
					$maxOrderWeight = floatval($this->config->get('flatoptions_max_weight_'.$i));						
					//SWITCH CONDITION
					switch($this->config->get('flatoptions_condition_'.$i)){
						case 'byorder':
							if(	$minOrder <= $subTotal && ($maxOrder >= $subTotal || $maxOrder == 0)){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;
						case 'byitem':
							if( $minOrderItem <= $totalItem &&($maxOrderItem >= $totalItem || $maxOrderItem == 0)){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;
						case 'byweight':
							if( $minOrderWeight <= $weightTotal &&($maxOrderWeight >= $weightTotal || $maxOrderWeight == 0)){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;
						case 'byorderitem':
							if( ($minOrder <= $subTotal && ($maxOrder >= $subTotal || $maxOrder == 0)) && ($minOrderItem <= $totalItem &&($maxOrderItem >= $totalItem || $maxOrderItem == 0))){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;
						case 'byorderweight':
							if( ($minOrder <= $subTotal && ($maxOrder >= $subTotal || $maxOrder == 0)) && ($minOrderWeight <= $weightTotal &&($maxOrderWeight >= $weightTotal || $maxOrderWeight == 0))){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;
						case 'byitemweight':
							if( ($minOrderItem <= $totalItem &&($maxOrderItem >= $totalItem || $maxOrderItem == 0)) && ($minOrderWeight <= $weightTotal &&($maxOrderWeight >= $weightTotal || $maxOrderWeight == 0))){
								$optiondata[$this->config->get('flatoptions_order_'.$i).$scount] = $i;
								$scount++;
							}
							break;	
					}
				}
			}
		}
		
		if(count($optiondata)>0){
			ksort($optiondata);
			foreach($optiondata as $key => $val){
				$quote_data['flatoptions'.$val] = array(
					'code'         => 'flatoptions.flatoptions'.$val,
					'title'        => $this->config->get('flatoptions_title_'.$site_language.'_'.$val),
					'cost'         => $this->config->get('flatoptions_cost_'.$val),
					'tax_class_id' => $this->config->get('flatoptions_tax_class_id_'.$val),
					'text'         => $this->currency->format($this->tax->calculate($this->config->get('flatoptions_cost_'.$val), $this->config->get('flatoptions_tax_class_id_'.$val), $this->config->get('config_tax')))
				);
			}
		}
		
		if(count($quote_data)>0){
			$method_data = array(
        		'code'       => 'flatoptions',
        		'title'      => $this->config->get('flatoptions_custom_title'),
        		'quote'      => $quote_data,
				'sort_order' => $this->config->get('flatoptions_sort_order'),
        		'error'      => false
      		);
		}
		return $method_data;
	}
}
?>